/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 306
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x4, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx2BImode)
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 306
          || GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || GET_MODE (x2) != E_VNx4SImode)
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x3, 0, 2);
      operands[2] = x10;
      if (!register_operand (operands[2], E_VNx4BImode)
          || !register_operand (operands[1], E_VNx4SImode))
        return -1;
      return 1;

    case SUBREG:
    case TRUNCATE:
      operands[3] = x3;
      if (!subreg_lowpart_operator (operands[3], E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 306
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode
          || GET_MODE (x2) != E_VNx8HImode)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[4] = x6;
      x7 = XVECEXP (x4, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx8BImode)
          || !register_operand (operands[1], E_VNx8HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 306
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern44 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1
      || GET_MODE (x4) != i2)
    return -1;
  return 0;
}

int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!aarch64_tls_le_symref (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern55 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern55 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern55 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern55 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern55 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern55 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_QImode:
      if (pattern68 (x3, 
E_VNx16QImode, 
E_VNx16BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_HImode:
      if (pattern68 (x3, 
E_VNx8HImode, 
E_VNx8BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_SImode:
      if (pattern68 (x3, 
E_VNx4SImode, 
E_VNx4BImode, 
E_SImode) != 0)
        return -1;
      return 8;

    case E_DImode:
      if (pattern68 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          return pattern55 (x3, 
E_V8QImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern55 (x3, 
E_V16QImode) != 0)
            return -1;
          return 1;

        case E_V4HImode:
          if (pattern55 (x3, 
E_V4HImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern55 (x3, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V2SImode:
          if (pattern55 (x3, 
E_V2SImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern55 (x3, 
E_V4SImode) != 0)
            return -1;
          return 5;

        case E_V2DImode:
          if (pattern55 (x3, 
E_V2DImode) != 0)
            return -1;
          return 6;

        case E_QImode:
          if (pattern55 (x3, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_HImode:
          if (pattern55 (x3, 
E_HImode) != 0)
            return -1;
          return 8;

        case E_SImode:
          if (pattern55 (x3, 
E_SImode) != 0)
            return -1;
          return 9;

        case E_DImode:
          if (pattern55 (x3, 
E_DImode) != 0)
            return -1;
          return 10;

        default:
          return -1;
        }

    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern78 (x3, 
E_V8QImode) != 0)
            return -1;
          return 11;

        case E_V16QImode:
          if (pattern78 (x3, 
E_V16QImode) != 0)
            return -1;
          return 12;

        case E_V4HImode:
          if (pattern79 (x3, 
E_V4HImode) != 0)
            return -1;
          return 13;

        case E_V8HImode:
          if (pattern79 (x3, 
E_V8HImode) != 0)
            return -1;
          return 14;

        case E_V2SImode:
          if (pattern80 (x3, 
E_V2SImode) != 0)
            return -1;
          return 15;

        case E_V4SImode:
          if (pattern80 (x3, 
E_V4SImode) != 0)
            return -1;
          return 16;

        case E_V2DImode:
          if (pattern81 (x3, 
E_V2DImode) != 0)
            return -1;
          return 17;

        case E_QImode:
          if (pattern78 (x3, 
E_QImode) != 0)
            return -1;
          return 18;

        case E_HImode:
          if (pattern79 (x3, 
E_HImode) != 0)
            return -1;
          return 19;

        case E_SImode:
          if (pattern80 (x3, 
E_SImode) != 0)
            return -1;
          return 20;

        case E_DImode:
          if (pattern81 (x3, 
E_DImode) != 0)
            return -1;
          return 21;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8SImode:
          if (!register_operand (operands[1], E_VNx8SImode))
            return -1;
          return 0;

        case E_VNx8DImode:
          if (!register_operand (operands[1], E_VNx8DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 3;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern150 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_di (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern152 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern152 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern153 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern153 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern154 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern154 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern155 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_DImode:
      if (pattern155 (x3, 
E_DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  return pattern170 (
i1); /* [-1, 2] */
}

int
pattern173 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx8BImode:
      if (!register_operand (operands[1], E_VNx8BImode)
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 0;

    case E_VNx4BImode:
      if (!register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 1;

    case E_VNx2BImode:
      if (!register_operand (operands[1], E_VNx2BImode)
          || !register_operand (operands[2], E_VNx2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern182 (x3, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern182 (x3, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern182 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern182 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern188 (x3, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern188 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern188 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern188 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          return pattern185 (x2, 
E_V16QImode, 
E_V4SFmode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern185 (x2, 
E_VNx16QImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern197 (x2, 
E_V4SFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern209 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern209 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern209 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x4 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x2, 0, 4);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern239 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[2], E_VNx32QImode)
          || !aligned_register_operand (operands[3], E_VNx32QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[2], E_VNx64QImode)
          || !aligned_register_operand (operands[3], E_VNx64QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode)
          || !aligned_register_operand (operands[3], E_VNx16HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode)
          || !aligned_register_operand (operands[3], E_VNx32HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[2], E_VNx32QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32QImode
          || !register_operand (operands[3], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[2], E_VNx64QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx64QImode
          || !register_operand (operands[3], E_VNx16QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx16HImode
          || !register_operand (operands[3], E_VNx8HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32HImode
          || !register_operand (operands[3], E_VNx8HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern250 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !const_0_to_7_operand (operands[1], E_SImode)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[1] = x7;
      x8 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[2] = x8;
          switch (GET_MODE (x5))
            {
            case E_VNx8SFmode:
              return pattern230 (x2, 
E_VNx8SFmode); /* [-1, 0] */

            case E_VNx16SFmode:
              if (pattern230 (x2, 
E_VNx16SFmode) != 0)
                return -1;
              return 1;

            case E_VNx4DFmode:
              if (pattern230 (x2, 
E_VNx4DFmode) != 0)
                return -1;
              return 2;

            case E_VNx8DFmode:
              if (pattern230 (x2, 
E_VNx8DFmode) != 0)
                return -1;
              return 3;

            case E_VNx16HFmode:
              if (pattern230 (x2, 
E_VNx16HFmode) != 0)
                return -1;
              return 4;

            case E_VNx32HFmode:
              if (pattern230 (x2, 
E_VNx32HFmode) != 0)
                return -1;
              return 5;

            case E_VNx16BFmode:
              if (pattern230 (x2, 
E_VNx16BFmode) != 0)
                return -1;
              return 6;

            case E_VNx32BFmode:
              if (pattern230 (x2, 
E_VNx32BFmode) != 0)
                return -1;
              return 7;

            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx8BFmode:
                  if (!register_operand (operands[1], E_VNx8BFmode)
                      || !register_operand (operands[2], E_VNx8BFmode))
                    return -1;
                  return 8;

                case E_VNx8HFmode:
                  if (!register_operand (operands[1], E_VNx8HFmode)
                      || !register_operand (operands[2], E_VNx8HFmode))
                    return -1;
                  return 9;

                case E_VNx16BFmode:
                  if (!aligned_register_operand (operands[1], E_VNx16BFmode)
                      || !aligned_register_operand (operands[2], E_VNx16BFmode))
                    return -1;
                  return 10;

                case E_VNx32BFmode:
                  if (!aligned_register_operand (operands[1], E_VNx32BFmode)
                      || !aligned_register_operand (operands[2], E_VNx32BFmode))
                    return -1;
                  return 11;

                case E_VNx16HFmode:
                  if (!aligned_register_operand (operands[1], E_VNx16HFmode)
                      || !aligned_register_operand (operands[2], E_VNx16HFmode))
                    return -1;
                  return 12;

                case E_VNx32HFmode:
                  if (!aligned_register_operand (operands[1], E_VNx32HFmode)
                      || !aligned_register_operand (operands[2], E_VNx32HFmode))
                    return -1;
                  return 13;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (x5))
            {
            case E_VNx8SFmode:
              if (pattern231 (x2, 
E_VNx8SFmode, 
E_VNx4SFmode) != 0)
                return -1;
              return 14;

            case E_VNx16SFmode:
              if (pattern231 (x2, 
E_VNx16SFmode, 
E_VNx4SFmode) != 0)
                return -1;
              return 15;

            case E_VNx4DFmode:
              if (pattern231 (x2, 
E_VNx4DFmode, 
E_VNx2DFmode) != 0)
                return -1;
              return 16;

            case E_VNx8DFmode:
              if (pattern231 (x2, 
E_VNx8DFmode, 
E_VNx2DFmode) != 0)
                return -1;
              return 17;

            case E_VNx16HFmode:
              if (pattern231 (x2, 
E_VNx16HFmode, 
E_VNx8HFmode) != 0)
                return -1;
              return 18;

            case E_VNx32HFmode:
              if (pattern231 (x2, 
E_VNx32HFmode, 
E_VNx8HFmode) != 0)
                return -1;
              return 19;

            case E_VNx16BFmode:
              if (pattern231 (x2, 
E_VNx16BFmode, 
E_VNx8BFmode) != 0)
                return -1;
              return 20;

            case E_VNx32BFmode:
              if (pattern231 (x2, 
E_VNx32BFmode, 
E_VNx8BFmode) != 0)
                return -1;
              return 21;

            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              res = pattern247 (x8);
              if (res >= 0)
                return res + 22; /* [22, 25] */
              return -1;

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 167)
            return -1;
          x10 = XVECEXP (x8, 0, 0);
          operands[2] = x10;
          x11 = XVECEXP (x8, 0, 1);
          operands[3] = x11;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_VNx8SFmode:
              if (pattern248 (x2, 
E_VNx8SFmode, 
E_VNx4SFmode) != 0)
                return -1;
              return 26;

            case E_VNx16SFmode:
              if (pattern248 (x2, 
E_VNx16SFmode, 
E_VNx4SFmode) != 0)
                return -1;
              return 27;

            case E_VNx4DFmode:
              if (pattern248 (x2, 
E_VNx4DFmode, 
E_VNx2DFmode) != 0)
                return -1;
              return 28;

            case E_VNx8DFmode:
              if (pattern248 (x2, 
E_VNx8DFmode, 
E_VNx2DFmode) != 0)
                return -1;
              return 29;

            case E_VNx16HFmode:
              if (pattern248 (x2, 
E_VNx16HFmode, 
E_VNx8HFmode) != 0)
                return -1;
              return 30;

            case E_VNx32HFmode:
              if (pattern248 (x2, 
E_VNx32HFmode, 
E_VNx8HFmode) != 0)
                return -1;
              return 31;

            case E_VNx16BFmode:
              if (pattern248 (x2, 
E_VNx16BFmode, 
E_VNx8BFmode) != 0)
                return -1;
              return 32;

            case E_VNx32BFmode:
              if (pattern248 (x2, 
E_VNx32BFmode, 
E_VNx8BFmode) != 0)
                return -1;
              return 33;

            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx8BFmode:
                  if (!register_operand (operands[1], E_VNx8BFmode)
                      || GET_MODE (x8) != E_VNx8BFmode
                      || !register_operand (operands[2], E_VNx8BFmode))
                    return -1;
                  return 34;

                case E_VNx16BFmode:
                  if (!aligned_register_operand (operands[1], E_VNx16BFmode)
                      || GET_MODE (x8) != E_VNx16BFmode
                      || !register_operand (operands[2], E_VNx8BFmode))
                    return -1;
                  return 35;

                case E_VNx32BFmode:
                  if (!aligned_register_operand (operands[1], E_VNx32BFmode)
                      || GET_MODE (x8) != E_VNx32BFmode
                      || !register_operand (operands[2], E_VNx8BFmode))
                    return -1;
                  return 36;

                case E_VNx8HFmode:
                  if (!register_operand (operands[1], E_VNx8HFmode)
                      || GET_MODE (x8) != E_VNx8HFmode
                      || !register_operand (operands[2], E_VNx8HFmode))
                    return -1;
                  return 37;

                case E_VNx16HFmode:
                  if (!aligned_register_operand (operands[1], E_VNx16HFmode)
                      || GET_MODE (x8) != E_VNx16HFmode
                      || !register_operand (operands[2], E_VNx8HFmode))
                    return -1;
                  return 38;

                case E_VNx32HFmode:
                  if (!aligned_register_operand (operands[1], E_VNx32HFmode)
                      || GET_MODE (x8) != E_VNx32HFmode
                      || !register_operand (operands[2], E_VNx8HFmode))
                    return -1;
                  return 39;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x12 = XEXP (x6, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x6, 1);
      operands[1] = x13;
      x7 = XVECEXP (x2, 0, 3);
      operands[2] = x7;
      x8 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          switch (GET_MODE (x5))
            {
            case E_VNx8SFmode:
              if (pattern249 (x2, 
E_VNx8SFmode) != 0)
                return -1;
              return 40;

            case E_VNx16SFmode:
              if (pattern249 (x2, 
E_VNx16SFmode) != 0)
                return -1;
              return 41;

            case E_VNx4DFmode:
              if (pattern249 (x2, 
E_VNx4DFmode) != 0)
                return -1;
              return 42;

            case E_VNx8DFmode:
              if (pattern249 (x2, 
E_VNx8DFmode) != 0)
                return -1;
              return 43;

            case E_VNx16HFmode:
              if (pattern249 (x2, 
E_VNx16HFmode) != 0)
                return -1;
              return 44;

            case E_VNx32HFmode:
              if (pattern249 (x2, 
E_VNx32HFmode) != 0)
                return -1;
              return 45;

            case E_VNx16BFmode:
              if (pattern249 (x2, 
E_VNx16BFmode) != 0)
                return -1;
              return 46;

            case E_VNx32BFmode:
              if (pattern249 (x2, 
E_VNx32BFmode) != 0)
                return -1;
              return 47;

            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              return 48;

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          switch (GET_MODE (x5))
            {
            case E_VNx8SFmode:
              if (pattern250 (x2, 
E_VNx8SFmode, 
E_VNx4SFmode) != 0)
                return -1;
              return 49;

            case E_VNx16SFmode:
              if (pattern250 (x2, 
E_VNx16SFmode, 
E_VNx4SFmode) != 0)
                return -1;
              return 50;

            case E_VNx4DFmode:
              if (pattern250 (x2, 
E_VNx4DFmode, 
E_VNx2DFmode) != 0)
                return -1;
              return 51;

            case E_VNx8DFmode:
              if (pattern250 (x2, 
E_VNx8DFmode, 
E_VNx2DFmode) != 0)
                return -1;
              return 52;

            case E_VNx16HFmode:
              if (pattern250 (x2, 
E_VNx16HFmode, 
E_VNx8HFmode) != 0)
                return -1;
              return 53;

            case E_VNx32HFmode:
              if (pattern250 (x2, 
E_VNx32HFmode, 
E_VNx8HFmode) != 0)
                return -1;
              return 54;

            case E_VNx16BFmode:
              if (pattern250 (x2, 
E_VNx16BFmode, 
E_VNx8BFmode) != 0)
                return -1;
              return 55;

            case E_VNx32BFmode:
              if (pattern250 (x2, 
E_VNx32BFmode, 
E_VNx8BFmode) != 0)
                return -1;
              return 56;

            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode
                  || !const_0_to_6_step_2_operand (operands[1], E_SImode))
                return -1;
              res = pattern251 (x8);
              if (res >= 0)
                return res + 57; /* [57, 60] */
              return -1;

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 167)
            return -1;
          x10 = XVECEXP (x8, 0, 0);
          operands[3] = x10;
          x11 = XVECEXP (x8, 0, 1);
          operands[4] = x11;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_VNx8SFmode:
              if (pattern252 (x2, 
E_VNx8SFmode, 
E_VNx4SFmode) != 0)
                return -1;
              return 61;

            case E_VNx16SFmode:
              if (pattern252 (x2, 
E_VNx16SFmode, 
E_VNx4SFmode) != 0)
                return -1;
              return 62;

            case E_VNx4DFmode:
              if (pattern252 (x2, 
E_VNx4DFmode, 
E_VNx2DFmode) != 0)
                return -1;
              return 63;

            case E_VNx8DFmode:
              if (pattern252 (x2, 
E_VNx8DFmode, 
E_VNx2DFmode) != 0)
                return -1;
              return 64;

            case E_VNx16HFmode:
              if (pattern252 (x2, 
E_VNx16HFmode, 
E_VNx8HFmode) != 0)
                return -1;
              return 65;

            case E_VNx32HFmode:
              if (pattern252 (x2, 
E_VNx32HFmode, 
E_VNx8HFmode) != 0)
                return -1;
              return 66;

            case E_VNx16BFmode:
              if (pattern252 (x2, 
E_VNx16BFmode, 
E_VNx8BFmode) != 0)
                return -1;
              return 67;

            case E_VNx32BFmode:
              if (pattern252 (x2, 
E_VNx32BFmode, 
E_VNx8BFmode) != 0)
                return -1;
              return 68;

            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              return 69;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern377 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CC_SWPmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CC_SWPmode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  return pattern376 (x4); /* [-1, 1] */
}

int
pattern382 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern381 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern381 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern381 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern389 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern393 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern396 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XINT (x2, 1) != 125)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern395 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern395 (x1, 
E_VNx8QImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern395 (x1, 
E_VNx4QImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern395 (x1, 
E_VNx2QImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern395 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern395 (x1, 
E_VNx4HImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern395 (x1, 
E_VNx2HImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern395 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern395 (x1, 
E_VNx2SImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern395 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern408 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern407 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern407 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern407 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern415 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern318 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern318 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern318 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern318 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern318 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern422 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || GET_MODE (x3) != E_V8QImode
          || GET_MODE (x4) != E_V8HImode
          || !register_operand (operands[2], E_V8HImode)
          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x3) != E_V4HImode
          || GET_MODE (x4) != E_V4SImode
          || !register_operand (operands[2], E_V4SImode)
          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x3) != E_V2SImode
          || GET_MODE (x4) != E_V2DImode
          || !register_operand (operands[2], E_V2DImode)
          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern437 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (XINT (x4, 1))
        {
        case 168:
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          return 0;

        case 306:
          x6 = XVECEXP (x4, 0, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[3] = x5;
          x7 = XVECEXP (x4, 0, 2);
          operands[2] = x7;
          if (!register_operand (operands[2], E_VNx2BImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3
          || !register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (XINT (x3, 1))
        {
        case 168:
          x8 = XVECEXP (x3, 0, 0);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          operands[3] = x9;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          return 2;

        case 306:
          x9 = XVECEXP (x3, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          operands[3] = x8;
          x10 = XVECEXP (x3, 0, 2);
          operands[2] = x10;
          if (!register_operand (operands[2], E_VNx4BImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case SUBREG:
    case TRUNCATE:
      if (!subreg_lowpart_operator (x3, E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || !register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (XINT (x4, 1))
        {
        case 168:
          operands[5] = x3;
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          return 4;

        case 306:
          x6 = XVECEXP (x4, 0, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          operands[3] = x3;
          x5 = XVECEXP (x4, 0, 0);
          operands[4] = x5;
          x7 = XVECEXP (x4, 0, 2);
          operands[2] = x7;
          if (!register_operand (operands[2], E_VNx8BImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern473 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_select_half (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vect_par_cnst_select_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern480 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern479 (x1, 
E_SImode); /* [-1, 3] */

    case E_DImode:
      res = pattern479 (x1, 
E_DImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern488 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern493 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern500 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern499 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern499 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern499 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern499 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern499 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_DImode:
      if (pattern499 (x1, 
E_V2DImode, 
E_DImode, 
E_V2SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern514 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern520 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return pattern518 (x1); /* [-1, 5] */

    case ABS:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ABS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern519 (x1, 
E_V4HFmode, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern519 (x1, 
E_V2SFmode, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        case E_V2DImode:
          if (pattern519 (x1, 
E_DFmode, 
E_DImode, 
E_V2DImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern532 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V2SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  return pattern531 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern540 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern544 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (!register_operand (x7, i1))
    return -1;
  return 0;
}

int
pattern555 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!aarch64_sync_memory_operand (operands[1], E_QImode))
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_QImode
              || !aarch64_reg_or_imm (operands[2], E_QImode)
              || !aarch64_reg_or_zero (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!aarch64_sync_memory_operand (operands[1], E_HImode))
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_HImode
              || !aarch64_plushi_operand (operands[2], E_HImode)
              || !aarch64_reg_or_zero (operands[3], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      operands[1] = x3;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          x7 = XEXP (x5, 1);
          if (pattern554 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          x7 = XEXP (x5, 1);
          if (pattern554 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || !aarch64_sync_memory_operand (operands[1], E_TImode))
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_TImode
              || !aarch64_reg_or_zero (operands[2], E_TImode)
              || !aarch64_reg_or_zero (operands[3], E_TImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern583 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_VNx2QImode:
      if (!aarch64_gather_scale_operand_b (operands[4], E_DImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!aarch64_gather_scale_operand_h (operands[4], E_DImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!aarch64_gather_scale_operand_w (operands[4], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern587 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern586 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 5] */

    case E_VNx4HImode:
      res = pattern586 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    case E_VNx2HImode:
      res = pattern586 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 12; /* [12, 17] */
      return -1;

    case E_VNx4SImode:
      res = pattern586 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 18; /* [18, 23] */
      return -1;

    case E_VNx2SImode:
      res = pattern586 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 24; /* [24, 29] */
      return -1;

    case E_VNx2DImode:
      res = pattern586 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 30; /* [30, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern598 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      return pattern466 (x1, 
E_VNx4SImode, 
E_VNx4BImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern466 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern604 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern611 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern618 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern623 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[3] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern632 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern631 (x1, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern631 (x1, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern631 (x1, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern640 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern290 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern290 (x1, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern290 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern290 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern647 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern655 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern660 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern655 (x1, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern655 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern659 (x1, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (pattern659 (x1, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 1)
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x7 = XVECEXP (x6, 0, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x4 = XEXP (x1, 1);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || GET_MODE (x3) != E_HImode
              || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V4HImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V4HImode:
              if (!register_operand (operands[2], E_V4HImode))
                return -1;
              return 4;

            case E_V8HImode:
              if (!register_operand (operands[2], E_V8HImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || GET_MODE (x3) != E_SImode
              || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V2SImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V2SImode:
              if (!register_operand (operands[2], E_V2SImode))
                return -1;
              return 6;

            case E_V4SImode:
              if (!register_operand (operands[2], E_V4SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern687 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 14
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 15
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 16
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_DImode)
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 18
      || GET_MODE (x11) != E_DImode)
    return -1;
  x12 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 30
      || GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XVECEXP (x1, 0, 8);
  return pattern686 (x14, 
E_CCmode, 
66); /* [-1, 0] */
}

int
pattern700 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      return pattern696 (x1, 
E_VNx4SImode, 
E_VNx4BImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern696 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern702 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern441 (x4, 
66, 
CLOBBER, 
E_CCmode); /* [-1, 0] */
}

int
pattern708 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_mem_pair_lanes_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_stp_reg_operand (operands[1], i1)
      || !aarch64_stp_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern711 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], E_VNx8BImode)
      || !aarch64_sve_ld1ro_operand_h (operands[1], E_OImode))
    return -1;
  return 0;
}

int
pattern713 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], E_VNx2BImode)
      || !aarch64_sve_ld1ro_operand_d (operands[1], E_OImode))
    return -1;
  return 0;
}

int
pattern719 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!register_operand (x2, i2))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern724 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (!register_operand (x3, E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x3;
      return 0;

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 1;

    case ASHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 2;

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 3;

    case ROTATERT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 4;

    case ROTATE:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 5;

    default:
      return -1;
    }
}

int
pattern751 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern748 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern748 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern748 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern748 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern759 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern767 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CC_Zmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_Zmode
      || !register_operand (operands[0], E_DImode))
    return -1;
  return 0;
}

int
pattern776 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern775 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern775 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern775 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern775 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern790 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern798 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_reg_or_zero (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_borrow_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern805 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern811 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern816 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x4, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern815 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern815 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern815 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern830 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[5] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern838 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i2)
      || !aarch64_simd_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern843 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern850 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_VNx4SImode
      || !register_operand (operands[0], E_VNx4SImode)
      || GET_MODE (x1) != E_VNx4SImode
      || !register_operand (operands[1], E_VNx4BImode)
      || !register_operand (operands[2], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern855 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern854 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern854 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern854 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern864 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || !register_operand (operands[1], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[3], E_VNx16QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[4], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode)
          || GET_MODE (x2) != E_VNx8BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[3], E_VNx8QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[4], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[3], E_VNx8HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[4], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[3], E_VNx4QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[4], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[3], E_VNx4HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[4], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[3], E_VNx4SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[4], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode)
          || GET_MODE (x2) != E_VNx2BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[3], E_VNx2QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[4], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[3], E_VNx2HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[4], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[3], E_VNx2SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[4], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[3], E_VNx2DImode)
              || !aarch64_sve_cmp_vsd_operand (operands[4], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern903 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_NZmode
      || GET_MODE (x3) != E_CC_NZmode)
    return -1;
  return 0;
}

int
pattern910 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern952 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern898 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern898 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern898 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern958 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern964 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[4] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          return pattern962 (x1, 
E_VNx8BImode, 
E_VNx8HFmode); /* [-1, 0] */

        case E_VNx4BImode:
          if (pattern962 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 1;

        case E_VNx2BImode:
          if (pattern962 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case NOT:
      x4 = XEXP (x3, 0);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern963 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 3;

        case E_VNx4BImode:
          if (pattern963 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 4;

        case E_VNx2BImode:
          if (pattern963 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern976 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern981 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[4], i1))
    return -1;
  return 0;
}

int
pattern988 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern997 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern335 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1000 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2TImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2TImode
      || !register_operand (operands[1], E_V2DImode)
      || !aarch64_int_rnd_operand (operands[3], E_V2TImode)
      || !aarch64_simd_shift_imm_vec_di (operands[2], E_V2DImode))
    return -1;
  return 0;
}

int
pattern1010 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HFmode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[2], E_V4HFmode)
          || !register_operand (operands[1], E_V4HFmode)
          || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 0;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[2], E_V2SFmode)
          || !register_operand (operands[3], E_V2SFmode)
          || !register_operand (operands[1], E_V2SFmode)
          || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1028 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1026 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1026 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1026 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1026 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern1027 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx8HFmode:
          if (pattern1027 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 5;

        case E_VNx4SFmode:
          if (pattern1027 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 6;

        case E_VNx2DFmode:
          if (pattern1027 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1052 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1058 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1066 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1073 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1)
      || !aarch64_simd_umax_half_mode (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1083 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_MODE (x5) != E_CC_Vmode
      || GET_MODE (x2) != E_CC_Vmode)
    return -1;
  return 0;
}

int
pattern1088 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_mul_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1092 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1096 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !aarch64_simd_reg_or_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1101 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1111 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1120 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x4, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern1119 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern1119 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern1119 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern1119 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1134 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1144 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1152 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1161 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || !register_operand (operands[1], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[3], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode)
          || GET_MODE (x2) != E_VNx8BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[3], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[3], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[3], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[3], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[3], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode)
          || GET_MODE (x2) != E_VNx2BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[3], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[3], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[3], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[3], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1212 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[4] = x3;
  if (!register_operand (operands[4], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[5] = x4;
  if (!memory_operand (operands[5], E_SImode))
    return -1;
  x5 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x5, 0);
  operands[6] = x7;
  if (!register_operand (operands[6], E_DImode))
    return -1;
  x8 = XEXP (x6, 0);
  operands[7] = x8;
  if (!memory_operand (operands[7], E_SImode))
    return -1;
  return 0;
}

int
pattern1224 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1230 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  x6 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  return pattern1081 (x7, 
i1); /* [-1, 1] */
}

int
pattern1238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  switch (GET_MODE (x9))
    {
    case E_SImode:
      return pattern1237 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1237 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XVECEXP (x4, 0, 0);
  operands[5] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[6] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern450 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern450 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern450 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1254 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_plus_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_logical_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1268 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i2))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !vect_par_cnst_even_or_odd_half (operands[4], i2))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1281 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !vect_par_cnst_hi_half (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1292 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1297 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_carry_operation (operands[2], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !aarch64_carry_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1311 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[2], E_VNx16BFmode)
          || !aligned_register_operand (operands[3], E_VNx16BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[2], E_VNx32BFmode)
          || !aligned_register_operand (operands[3], E_VNx32BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[2], E_VNx16HFmode)
          || !aligned_register_operand (operands[3], E_VNx16HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[2], E_VNx32HFmode)
          || !aligned_register_operand (operands[3], E_VNx32HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1321 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1326 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || pattern1276 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1331 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[1], E_V2DImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1339 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_mem_pair_operator (operands[7], i1)
      || !aarch64_stp_reg_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[10] = x4;
  x5 = XEXP (x4, 1);
  operands[5] = x5;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !aarch64_stp_reg_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[4]))
    return -1;
  return 0;
}

int
pattern1349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode)
          || GET_MODE (x1) != E_VNx16HImode)
        return -1;
      return 0;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode)
          || GET_MODE (x1) != E_VNx32HImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  if (!cc_register (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case COMPARE:
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 113)
        return -1;
      x8 = XEXP (x1, 0);
      operands[1] = x8;
      operands[4] = x3;
      operands[0] = x5;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      x11 = XVECEXP (x7, 0, 0);
      operands[5] = x11;
      if (!immediate_operand (operands[5], E_VOIDmode))
        return -1;
      if (cc_register (operands[1], E_CCmode)
          && GET_MODE (x2) == E_CCmode
          && GET_MODE (x6) == E_CCmode
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && aarch64_ccmp_operand (operands[3], E_SImode))
                return 7; /* ccmpccsi */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && aarch64_ccmp_operand (operands[3], E_DImode))
                return 8; /* ccmpccdi */
              break;

            default:
              break;
            }
        }
      if (cc_register (operands[1], E_CCFPmode))
        {
          switch (pattern1244 (x2, 
E_CCFPmode))
            {
            case 0:
              if (
#line 764 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 9; /* ccmpccfpsf */
              break;

            case 1:
              if (
#line 764 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 10; /* ccmpccfpdf */
              break;

            default:
              break;
            }
        }
      if (!cc_register (operands[1], E_CCFPEmode))
        return -1;
      switch (pattern1244 (x2, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 764 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 11; /* ccmpccfpesf */

        case 1:
          if (!
#line 764 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 12; /* ccmpccfpedf */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 113)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != COMPARE)
        return -1;
      x8 = XEXP (x1, 0);
      operands[1] = x8;
      operands[4] = x3;
      operands[0] = x5;
      x12 = XVECEXP (x6, 0, 0);
      operands[5] = x12;
      if (!immediate_operand (operands[5], E_VOIDmode))
        return -1;
      x13 = XEXP (x7, 0);
      operands[2] = x13;
      x14 = XEXP (x7, 1);
      operands[3] = x14;
      if (cc_register (operands[1], E_CCmode)
          && GET_MODE (x2) == E_CCmode
          && GET_MODE (x6) == E_CCmode
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && aarch64_ccmp_operand (operands[3], E_SImode))
                return 13; /* ccmpccsi_rev */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && aarch64_ccmp_operand (operands[3], E_DImode))
                return 14; /* ccmpccdi_rev */
              break;

            default:
              break;
            }
        }
      if (cc_register (operands[1], E_CCFPmode))
        {
          switch (pattern1245 (x2, 
E_CCFPmode))
            {
            case 0:
              if (
#line 801 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 15; /* ccmpccfpsf_rev */
              break;

            case 1:
              if (
#line 801 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 16; /* ccmpccfpdf_rev */
              break;

            default:
              break;
            }
        }
      if (!cc_register (operands[1], E_CCFPEmode))
        return -1;
      switch (pattern1245 (x2, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 801 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 17; /* ccmpccfpesf_rev */

        case 1:
          if (!
#line 801 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 18; /* ccmpccfpedf_rev */

        default:
          return -1;
        }

    case LABEL_REF:
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      operands[0] = x3;
      operands[1] = x5;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      return 19; /* condjump */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[3] = x6;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      operands[1] = x3;
      operands[2] = x5;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern1038 (x2, 
E_QImode) != 0
              || !
#line 4513 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 454; /* *cmovqi_insn */

        case E_HImode:
          if (pattern1038 (x2, 
E_HImode) != 0
              || !
#line 4513 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 455; /* *cmovhi_insn */

        case E_SImode:
          if (pattern1038 (x2, 
E_SImode) != 0
              || !
#line 4513 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 456; /* *cmovsi_insn */

        case E_DImode:
          if (pattern1038 (x2, 
E_DImode) != 0
              || !
#line 4513 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 457; /* *cmovdi_insn */

        case E_SFmode:
          if (pattern1039 (x2, 
E_SFmode) != 0
              || !
#line 4590 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 462; /* *cmovsf_insn */

        case E_DFmode:
          if (pattern1039 (x2, 
E_DFmode) != 0
              || !
#line 4590 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 463; /* *cmovdf_insn */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != ZERO_EXTEND
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      operands[1] = x3;
      operands[2] = x5;
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x13 = XEXP (x7, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 461; /* *cmovdi_insn_uxtw */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      return recog_10 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
      switch (pattern587 (x2))
        {
        case 0:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
            return -1;
          return 6964; /* *zero_extendvnx8qivnx8hi2 */

        case 1:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
            return -1;
          return 6966; /* *zero_extendvnx4qivnx8hi2 */

        case 2:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
            return -1;
          return 6968; /* *zero_extendvnx2qivnx8hi2 */

        case 3:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
            return -1;
          return 6970; /* *zero_extendvnx4hivnx8hi2 */

        case 4:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
            return -1;
          return 6972; /* *zero_extendvnx2hivnx8hi2 */

        case 5:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
            return -1;
          return 6974; /* *zero_extendvnx2sivnx8hi2 */

        case 6:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
            return -1;
          return 6976; /* *zero_extendvnx8qivnx4hi2 */

        case 7:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
            return -1;
          return 6978; /* *zero_extendvnx4qivnx4hi2 */

        case 8:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
            return -1;
          return 6980; /* *zero_extendvnx2qivnx4hi2 */

        case 9:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
            return -1;
          return 6982; /* *zero_extendvnx4hivnx4hi2 */

        case 10:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
            return -1;
          return 6984; /* *zero_extendvnx2hivnx4hi2 */

        case 11:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
            return -1;
          return 6986; /* *zero_extendvnx2sivnx4hi2 */

        case 12:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
            return -1;
          return 6988; /* *zero_extendvnx8qivnx2hi2 */

        case 13:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
            return -1;
          return 6990; /* *zero_extendvnx4qivnx2hi2 */

        case 14:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
            return -1;
          return 6992; /* *zero_extendvnx2qivnx2hi2 */

        case 15:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
            return -1;
          return 6994; /* *zero_extendvnx4hivnx2hi2 */

        case 16:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
            return -1;
          return 6996; /* *zero_extendvnx2hivnx2hi2 */

        case 17:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
            return -1;
          return 6998; /* *zero_extendvnx2sivnx2hi2 */

        case 18:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
            return -1;
          return 7000; /* *zero_extendvnx8qivnx4si2 */

        case 19:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
            return -1;
          return 7002; /* *zero_extendvnx4qivnx4si2 */

        case 20:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
            return -1;
          return 7004; /* *zero_extendvnx2qivnx4si2 */

        case 21:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
            return -1;
          return 7006; /* *zero_extendvnx4hivnx4si2 */

        case 22:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
            return -1;
          return 7008; /* *zero_extendvnx2hivnx4si2 */

        case 23:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
            return -1;
          return 7010; /* *zero_extendvnx2sivnx4si2 */

        case 24:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
            return -1;
          return 7012; /* *zero_extendvnx8qivnx2si2 */

        case 25:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
            return -1;
          return 7014; /* *zero_extendvnx4qivnx2si2 */

        case 26:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
            return -1;
          return 7016; /* *zero_extendvnx2qivnx2si2 */

        case 27:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
            return -1;
          return 7018; /* *zero_extendvnx4hivnx2si2 */

        case 28:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
            return -1;
          return 7020; /* *zero_extendvnx2hivnx2si2 */

        case 29:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
            return -1;
          return 7022; /* *zero_extendvnx2sivnx2si2 */

        case 30:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
            return -1;
          return 7024; /* *zero_extendvnx8qivnx2di2 */

        case 31:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
            return -1;
          return 7026; /* *zero_extendvnx4qivnx2di2 */

        case 32:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
            return -1;
          return 7028; /* *zero_extendvnx2qivnx2di2 */

        case 33:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
            return -1;
          return 7030; /* *zero_extendvnx4hivnx2di2 */

        case 34:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
            return -1;
          return 7032; /* *zero_extendvnx2hivnx2di2 */

        case 35:
          if (!
#line 3355 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
            return -1;
          return 7034; /* *zero_extendvnx2sivnx2di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_15 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_13 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_16 (x1, insn, pnum_clobbers);

    case ABS:
      switch (pattern457 (x3))
        {
        case 0:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6540; /* aarch64_pred_absvnx16qi */

        case 1:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6549; /* aarch64_pred_absvnx8qi */

        case 2:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6558; /* aarch64_pred_absvnx4qi */

        case 3:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6567; /* aarch64_pred_absvnx2qi */

        case 4:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6576; /* aarch64_pred_absvnx8hi */

        case 5:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6585; /* aarch64_pred_absvnx4hi */

        case 6:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6594; /* aarch64_pred_absvnx2hi */

        case 7:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6603; /* aarch64_pred_absvnx4si */

        case 8:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6612; /* aarch64_pred_absvnx2si */

        case 9:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6621; /* aarch64_pred_absvnx2di */

        case 10:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6630; /* aarch64_pred_absv8qi */

        case 11:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6639; /* aarch64_pred_absv16qi */

        case 12:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6648; /* aarch64_pred_absv4hi */

        case 13:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6657; /* aarch64_pred_absv8hi */

        case 14:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6666; /* aarch64_pred_absv2si */

        case 15:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6675; /* aarch64_pred_absv4si */

        case 16:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6684; /* aarch64_pred_absv2di */

        case 17:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6693; /* aarch64_pred_absv1di */

        default:
          return -1;
        }

    case NEG:
      switch (pattern457 (x3))
        {
        case 0:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6541; /* aarch64_pred_negvnx16qi */

        case 1:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6550; /* aarch64_pred_negvnx8qi */

        case 2:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6559; /* aarch64_pred_negvnx4qi */

        case 3:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6568; /* aarch64_pred_negvnx2qi */

        case 4:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6577; /* aarch64_pred_negvnx8hi */

        case 5:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6586; /* aarch64_pred_negvnx4hi */

        case 6:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6595; /* aarch64_pred_negvnx2hi */

        case 7:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6604; /* aarch64_pred_negvnx4si */

        case 8:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6613; /* aarch64_pred_negvnx2si */

        case 9:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6622; /* aarch64_pred_negvnx2di */

        case 10:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6631; /* aarch64_pred_negv8qi */

        case 11:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6640; /* aarch64_pred_negv16qi */

        case 12:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6649; /* aarch64_pred_negv4hi */

        case 13:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6658; /* aarch64_pred_negv8hi */

        case 14:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6667; /* aarch64_pred_negv2si */

        case 15:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6676; /* aarch64_pred_negv4si */

        case 16:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6685; /* aarch64_pred_negv2di */

        case 17:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6694; /* aarch64_pred_negv1di */

        default:
          return -1;
        }

    case NOT:
      return recog_14 (x1, insn, pnum_clobbers);

    case CLRSB:
      switch (pattern457 (x3))
        {
        case 0:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6543; /* aarch64_pred_clrsbvnx16qi */

        case 1:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6552; /* aarch64_pred_clrsbvnx8qi */

        case 2:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6561; /* aarch64_pred_clrsbvnx4qi */

        case 3:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6570; /* aarch64_pred_clrsbvnx2qi */

        case 4:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6579; /* aarch64_pred_clrsbvnx8hi */

        case 5:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6588; /* aarch64_pred_clrsbvnx4hi */

        case 6:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6597; /* aarch64_pred_clrsbvnx2hi */

        case 7:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6606; /* aarch64_pred_clrsbvnx4si */

        case 8:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6615; /* aarch64_pred_clrsbvnx2si */

        case 9:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6624; /* aarch64_pred_clrsbvnx2di */

        case 10:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6633; /* aarch64_pred_clrsbv8qi */

        case 11:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6642; /* aarch64_pred_clrsbv16qi */

        case 12:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6651; /* aarch64_pred_clrsbv4hi */

        case 13:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6660; /* aarch64_pred_clrsbv8hi */

        case 14:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6669; /* aarch64_pred_clrsbv2si */

        case 15:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6678; /* aarch64_pred_clrsbv4si */

        case 16:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6687; /* aarch64_pred_clrsbv2di */

        case 17:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6696; /* aarch64_pred_clrsbv1di */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern457 (x3))
        {
        case 0:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6544; /* aarch64_pred_clzvnx16qi */

        case 1:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6553; /* aarch64_pred_clzvnx8qi */

        case 2:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6562; /* aarch64_pred_clzvnx4qi */

        case 3:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6571; /* aarch64_pred_clzvnx2qi */

        case 4:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6580; /* aarch64_pred_clzvnx8hi */

        case 5:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6589; /* aarch64_pred_clzvnx4hi */

        case 6:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6598; /* aarch64_pred_clzvnx2hi */

        case 7:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6607; /* aarch64_pred_clzvnx4si */

        case 8:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6616; /* aarch64_pred_clzvnx2si */

        case 9:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6625; /* aarch64_pred_clzvnx2di */

        case 10:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6634; /* aarch64_pred_clzv8qi */

        case 11:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6643; /* aarch64_pred_clzv16qi */

        case 12:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6652; /* aarch64_pred_clzv4hi */

        case 13:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6661; /* aarch64_pred_clzv8hi */

        case 14:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6670; /* aarch64_pred_clzv2si */

        case 15:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6679; /* aarch64_pred_clzv4si */

        case 16:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6688; /* aarch64_pred_clzv2di */

        case 17:
          if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6697; /* aarch64_pred_clzv1di */

        default:
          return -1;
        }

    case POPCOUNT:
      return recog_21 (x1, insn, pnum_clobbers);

    case BITREVERSE:
      return recog_20 (x1, insn, pnum_clobbers);

    case SS_ABS:
      return recog_19 (x1, insn, pnum_clobbers);

    case SS_NEG:
      return recog_18 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_12 (x1, insn, pnum_clobbers);

    case MULT:
      switch (pattern459 (x3))
        {
        case 0:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7335; /* aarch64_pred_mulvnx16qi */

        case 1:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7340; /* aarch64_pred_mulvnx8qi */

        case 2:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7345; /* aarch64_pred_mulvnx4qi */

        case 3:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7350; /* aarch64_pred_mulvnx2qi */

        case 4:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7355; /* aarch64_pred_mulvnx8hi */

        case 5:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7360; /* aarch64_pred_mulvnx4hi */

        case 6:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7365; /* aarch64_pred_mulvnx2hi */

        case 7:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7370; /* aarch64_pred_mulvnx4si */

        case 8:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7375; /* aarch64_pred_mulvnx2si */

        case 9:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7380; /* aarch64_pred_mulvnx2di */

        case 10:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7385; /* aarch64_pred_mulv2di */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern459 (x3))
        {
        case 0:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7336; /* aarch64_pred_smaxvnx16qi */

        case 1:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7341; /* aarch64_pred_smaxvnx8qi */

        case 2:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7346; /* aarch64_pred_smaxvnx4qi */

        case 3:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7351; /* aarch64_pred_smaxvnx2qi */

        case 4:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7356; /* aarch64_pred_smaxvnx8hi */

        case 5:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7361; /* aarch64_pred_smaxvnx4hi */

        case 6:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7366; /* aarch64_pred_smaxvnx2hi */

        case 7:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7371; /* aarch64_pred_smaxvnx4si */

        case 8:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7376; /* aarch64_pred_smaxvnx2si */

        case 9:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7381; /* aarch64_pred_smaxvnx2di */

        case 10:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7386; /* aarch64_pred_smaxv2di */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern462 (x3))
        {
        case 0:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7337; /* aarch64_pred_sminvnx16qi */

        case 1:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7342; /* aarch64_pred_sminvnx8qi */

        case 2:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7347; /* aarch64_pred_sminvnx4qi */

        case 3:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7352; /* aarch64_pred_sminvnx2qi */

        case 4:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7357; /* aarch64_pred_sminvnx8hi */

        case 5:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7362; /* aarch64_pred_sminvnx4hi */

        case 6:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7367; /* aarch64_pred_sminvnx2hi */

        case 7:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7372; /* aarch64_pred_sminvnx4si */

        case 8:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7377; /* aarch64_pred_sminvnx2si */

        case 9:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7382; /* aarch64_pred_sminvnx2di */

        case 10:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7387; /* aarch64_pred_sminv2di */

        case 11:
          if (!
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11511; /* *aarch64_sve_sclampvnx16qi_x */

        case 12:
          if (!
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11513; /* *aarch64_sve_sclampvnx8hi_x */

        case 13:
          if (!
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11515; /* *aarch64_sve_sclampvnx4si_x */

        case 14:
          if (!
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11517; /* *aarch64_sve_sclampvnx2di_x */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern464 (x3))
        {
        case 0:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7338; /* aarch64_pred_umaxvnx16qi */

        case 1:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7343; /* aarch64_pred_umaxvnx8qi */

        case 2:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7348; /* aarch64_pred_umaxvnx4qi */

        case 3:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7353; /* aarch64_pred_umaxvnx2qi */

        case 4:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7358; /* aarch64_pred_umaxvnx8hi */

        case 5:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7363; /* aarch64_pred_umaxvnx4hi */

        case 6:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7368; /* aarch64_pred_umaxvnx2hi */

        case 7:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7373; /* aarch64_pred_umaxvnx4si */

        case 8:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7378; /* aarch64_pred_umaxvnx2si */

        case 9:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7383; /* aarch64_pred_umaxvnx2di */

        case 10:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7388; /* aarch64_pred_umaxv2di */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern465 (x3))
        {
        case 0:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7339; /* aarch64_pred_uminvnx16qi */

        case 1:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7344; /* aarch64_pred_uminvnx8qi */

        case 2:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7349; /* aarch64_pred_uminvnx4qi */

        case 3:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7354; /* aarch64_pred_uminvnx2qi */

        case 4:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7359; /* aarch64_pred_uminvnx8hi */

        case 5:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7364; /* aarch64_pred_uminvnx4hi */

        case 6:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7369; /* aarch64_pred_uminvnx2hi */

        case 7:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7374; /* aarch64_pred_uminvnx4si */

        case 8:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7379; /* aarch64_pred_uminvnx2si */

        case 9:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7384; /* aarch64_pred_uminvnx2di */

        case 10:
          if (!
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7389; /* aarch64_pred_uminv2di */

        case 11:
          if (!
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11512; /* *aarch64_sve_uclampvnx16qi_x */

        case 12:
          if (!
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11514; /* *aarch64_sve_uclampvnx8hi_x */

        case 13:
          if (!
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11516; /* *aarch64_sve_uclampvnx4si_x */

        case 14:
          if (!
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11518; /* *aarch64_sve_uclampvnx2di_x */

        default:
          return -1;
        }

    case DIV:
      switch (pattern467 (x3))
        {
        case 0:
          if (!
#line 4614 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8121; /* aarch64_pred_divvnx4si */

        case 1:
          if (!
#line 4614 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8123; /* aarch64_pred_divvnx2di */

        case 2:
          if (!
#line 4614 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8125; /* aarch64_pred_divv4si */

        case 3:
          if (!
#line 4614 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8127; /* aarch64_pred_divv2di */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern467 (x3))
        {
        case 0:
          if (!
#line 4614 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8122; /* aarch64_pred_udivvnx4si */

        case 1:
          if (!
#line 4614 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8124; /* aarch64_pred_udivvnx2di */

        case 2:
          if (!
#line 4614 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8126; /* aarch64_pred_udivv4si */

        case 3:
          if (!
#line 4614 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8128; /* aarch64_pred_udivv2di */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern469 (x3))
        {
        case 0:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8201; /* aarch64_pred_ashlvnx16qi */

        case 1:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8204; /* aarch64_pred_ashlvnx8qi */

        case 2:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8207; /* aarch64_pred_ashlvnx4qi */

        case 3:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8210; /* aarch64_pred_ashlvnx2qi */

        case 4:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8213; /* aarch64_pred_ashlvnx8hi */

        case 5:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8216; /* aarch64_pred_ashlvnx4hi */

        case 6:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8219; /* aarch64_pred_ashlvnx2hi */

        case 7:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8222; /* aarch64_pred_ashlvnx4si */

        case 8:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8225; /* aarch64_pred_ashlvnx2si */

        case 9:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8228; /* aarch64_pred_ashlvnx2di */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (pattern591 (x3))
        {
        case 0:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8202; /* aarch64_pred_ashrvnx16qi */

        case 1:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8205; /* aarch64_pred_ashrvnx8qi */

        case 2:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8208; /* aarch64_pred_ashrvnx4qi */

        case 3:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8211; /* aarch64_pred_ashrvnx2qi */

        case 4:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8214; /* aarch64_pred_ashrvnx8hi */

        case 5:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8217; /* aarch64_pred_ashrvnx4hi */

        case 6:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8220; /* aarch64_pred_ashrvnx2hi */

        case 7:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8223; /* aarch64_pred_ashrvnx4si */

        case 8:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8226; /* aarch64_pred_ashrvnx2si */

        case 9:
          if (!
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8229; /* aarch64_pred_ashrvnx2di */

        default:
          return -1;
        }

    case LSHIFTRT:
      return recog_17 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern471 (x3))
        {
        case 0:
          if (!
#line 1627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11865; /* *aarch64_sve2_norvnx16qi */

        case 1:
          if (!
#line 1627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11866; /* *aarch64_sve2_norvnx8hi */

        case 2:
          if (!
#line 1627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11867; /* *aarch64_sve2_norvnx4si */

        case 3:
          if (!
#line 1627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11868; /* *aarch64_sve2_norvnx2di */

        default:
          return -1;
        }

    case IOR:
      switch (pattern471 (x3))
        {
        case 0:
          if (!
#line 1649 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11869; /* *aarch64_sve2_nandvnx16qi */

        case 1:
          if (!
#line 1649 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11870; /* *aarch64_sve2_nandvnx8hi */

        case 2:
          if (!
#line 1649 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11871; /* *aarch64_sve2_nandvnx4si */

        case 3:
          if (!
#line 1649 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11872; /* *aarch64_sve2_nandvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_simd_struct_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1DImode:
      if (!register_operand (operands[1], E_V1DImode)
          || !
#line 7665 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4578; /* aarch64_vec_stl1_lanesv1di_lanesi */

    case E_V1DFmode:
      if (!register_operand (operands[1], E_V1DFmode)
          || !
#line 7665 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4579; /* aarch64_vec_stl1_lanesv1df_lanedf */

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 7665 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4580; /* aarch64_vec_stl1_lanesv2di_lanedi */

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 7665 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4581; /* aarch64_vec_stl1_lanesv2df_lanedf */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern69 (x1))
    {
    case 0:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2108; /* aarch64_uminpv8qi */

    case 1:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2118; /* aarch64_uminpv16qi */

    case 2:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2124; /* aarch64_uminpv4hi */

    case 3:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2134; /* aarch64_uminpv8hi */

    case 4:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2140; /* aarch64_uminpv2si */

    case 5:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2150; /* aarch64_uminpv4si */

    case 6:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10343; /* aarch64_pred_reduc_umin_vnx16qi */

    case 7:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10350; /* aarch64_pred_reduc_umin_vnx8hi */

    case 8:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10357; /* aarch64_pred_reduc_umin_vnx4si */

    case 9:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10364; /* aarch64_pred_reduc_umin_vnx2di */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern120 (x1))
    {
    case 0:
      if (!
#line 3874 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12801; /* aarch64_sve_zipvnx32qi */

    case 1:
      if (!
#line 3874 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12803; /* aarch64_sve_zipvnx16hi */

    case 2:
      if (!
#line 3874 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12805; /* aarch64_sve_zipvnx8si */

    case 3:
      if (!
#line 3874 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12807; /* aarch64_sve_zipvnx4di */

    case 4:
      if (!
#line 3874 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12809; /* aarch64_sve_zipvnx16bf */

    case 5:
      if (!
#line 3874 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12811; /* aarch64_sve_zipvnx16hf */

    case 6:
      if (!
#line 3874 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12813; /* aarch64_sve_zipvnx8sf */

    case 7:
      if (!
#line 3874 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12815; /* aarch64_sve_zipvnx4df */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern89 (x1))
    {
    case 0:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6524; /* extract_after_last_vnx16qi */

    case 1:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6526; /* extract_after_last_vnx8hi */

    case 2:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6528; /* extract_after_last_vnx4si */

    case 3:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6530; /* extract_after_last_vnx2di */

    case 4:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6532; /* extract_after_last_vnx8bf */

    case 5:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6534; /* extract_after_last_vnx8hf */

    case 6:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6536; /* extract_after_last_vnx4sf */

    case 7:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6538; /* extract_after_last_vnx2df */

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern54 (x1))
    {
    case 0:
      return 1026; /* scvtfsi3 */

    case 1:
      return 1028; /* scvtfdi3 */

    case 2:
      if (!
#line 7181 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1034; /* scvtfsihf3 */

    case 3:
      if (!
#line 7181 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1036; /* scvtfdihf3 */

    case 4:
      if (!
#line 7201 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1040; /* scvtfhi3 */

    case 5:
      if (!(
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 287 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2627; /* scvtfv4hi3 */

    case 6:
      if (!(
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 288 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2629; /* scvtfv8hi3 */

    case 7:
      if (!
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2631; /* scvtfv2si3 */

    case 8:
      if (!
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2633; /* scvtfv4si3 */

    case 9:
      if (!
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2635; /* scvtfv2di3 */

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12071; /* aarch64_sve_umulltvnx8hi */

    case 1:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12092; /* aarch64_sve_umulltvnx4si */

    case 2:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12113; /* aarch64_sve_umulltvnx2di */

    case 3:
      if (!
#line 2282 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12121; /* aarch64_sve_umullt_lane_vnx4si */

    case 4:
      if (!
#line 2282 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12127; /* aarch64_sve_umullt_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12867; /* aarch64_sve_bgrpvnx16qi */

    case 1:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12870; /* aarch64_sve_bgrpvnx8hi */

    case 2:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12873; /* aarch64_sve_bgrpvnx4si */

    case 3:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12876; /* aarch64_sve_bgrpvnx2di */

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern117 (x1))
    {
    case 0:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12698; /* aarch64_pred_reduc_addqv_vnx16qi */

    case 1:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12706; /* aarch64_pred_reduc_addqv_vnx8hi */

    case 2:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12714; /* aarch64_pred_reduc_addqv_vnx4si */

    case 3:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12722; /* aarch64_pred_reduc_addqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern87 (x1))
    {
    case 0:
      if (!
#line 9880 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5311; /* aarch64_f2cvtlv8hf */

    case 1:
      if (!
#line 9880 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5313; /* aarch64_f2cvtlv8bf */

    case 2:
      if (!
#line 9893 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5315; /* aarch64_f2cvtlv8hf_high */

    case 3:
      if (!
#line 9893 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5317; /* aarch64_f2cvtlv8bf_high */

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 733 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1565; /* aarch64_rsqrtev4hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 733 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 182 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1566; /* aarch64_rsqrtev8hf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 733 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1567; /* aarch64_rsqrtev2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 733 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1568; /* aarch64_rsqrtev4sf */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 733 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1569; /* aarch64_rsqrtev2df */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 733 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1570; /* aarch64_rsqrtehf */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 733 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1571; /* aarch64_rsqrtesf */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 733 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1572; /* aarch64_rsqrtedf */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 760 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1581; /* aarch64_ursqrtev2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 760 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1582; /* aarch64_ursqrtev4si */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HFmode)
          || !
#line 3650 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 7161; /* aarch64_sve_frsqrtevnx8hf */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SFmode)
          || !
#line 3650 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 7163; /* aarch64_sve_frsqrtevnx4sf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2DFmode)
          || !
#line 3650 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 7165; /* aarch64_sve_frsqrtevnx2df */

    default:
      return -1;
    }
}

 int
recog_154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode)
          || GET_MODE (x3) != E_V2x8QImode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4394; /* aarch64_simd_ld2rv8qi */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode)
          || GET_MODE (x3) != E_V2x4HImode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4395; /* aarch64_simd_ld2rv4hi */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode)
          || GET_MODE (x3) != E_V2x2SImode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4396; /* aarch64_simd_ld2rv2si */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode)
          || GET_MODE (x3) != E_V2x1DImode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4397; /* aarch64_simd_ld2rdi */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode)
          || GET_MODE (x3) != E_V2x4HFmode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4398; /* aarch64_simd_ld2rv4hf */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode)
          || GET_MODE (x3) != E_V2x2SFmode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4399; /* aarch64_simd_ld2rv2sf */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode)
          || GET_MODE (x3) != E_V2x1DFmode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4400; /* aarch64_simd_ld2rdf */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode)
          || GET_MODE (x3) != E_V2x4BFmode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4401; /* aarch64_simd_ld2rv4bf */

    case E_V2x16QImode:
      if (!register_operand (operands[0], E_V2x16QImode)
          || GET_MODE (x3) != E_V2x16QImode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4402; /* aarch64_simd_ld2rv16qi */

    case E_V2x8HImode:
      if (!register_operand (operands[0], E_V2x8HImode)
          || GET_MODE (x3) != E_V2x8HImode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4403; /* aarch64_simd_ld2rv8hi */

    case E_V2x4SImode:
      if (!register_operand (operands[0], E_V2x4SImode)
          || GET_MODE (x3) != E_V2x4SImode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4404; /* aarch64_simd_ld2rv4si */

    case E_V2x2DImode:
      if (!register_operand (operands[0], E_V2x2DImode)
          || GET_MODE (x3) != E_V2x2DImode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4405; /* aarch64_simd_ld2rv2di */

    case E_V2x8HFmode:
      if (!register_operand (operands[0], E_V2x8HFmode)
          || GET_MODE (x3) != E_V2x8HFmode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4406; /* aarch64_simd_ld2rv8hf */

    case E_V2x4SFmode:
      if (!register_operand (operands[0], E_V2x4SFmode)
          || GET_MODE (x3) != E_V2x4SFmode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4407; /* aarch64_simd_ld2rv4sf */

    case E_V2x2DFmode:
      if (!register_operand (operands[0], E_V2x2DFmode)
          || GET_MODE (x3) != E_V2x2DFmode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4408; /* aarch64_simd_ld2rv2df */

    case E_V2x8BFmode:
      if (!register_operand (operands[0], E_V2x8BFmode)
          || GET_MODE (x3) != E_V2x8BFmode
          || !
#line 7373 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4409; /* aarch64_simd_ld2rv8bf */

    default:
      return -1;
    }
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 9777 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
        return -1;
      return 5266; /* aarch64_bfcvtnv4bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 9777 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
        return -1;
      return 5267; /* aarch64_bfcvtn_qv8bf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4BFmode:
          if (!register_operand (operands[1], E_V4BFmode)
              || !
#line 9806 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
            return -1;
          return 5270; /* aarch64_vbfcvtv4bf */

        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !
#line 9806 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
            return -1;
          return 5271; /* aarch64_vbfcvtv8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HImode)
          || !(
#line 3621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3240 "../../gcc/config/aarch64/iterators.md"
(TARGET_NON_STREAMING)))
        return -1;
      return 7157; /* aarch64_sve_fexpavnx8hf */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SImode)
          || !(
#line 3621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3240 "../../gcc/config/aarch64/iterators.md"
(TARGET_NON_STREAMING)))
        return -1;
      return 7158; /* aarch64_sve_fexpavnx4sf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2DImode)
          || !(
#line 3621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3240 "../../gcc/config/aarch64/iterators.md"
(TARGET_NON_STREAMING)))
        return -1;
      return 7159; /* aarch64_sve_fexpavnx2df */

    default:
      return -1;
    }
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern139 (x1))
    {
    case 0:
      if (!
#line 3902 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12850; /* aarch64_sve_uzpqvnx64qi */

    case 1:
      if (!
#line 3902 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12852; /* aarch64_sve_uzpqvnx32hi */

    case 2:
      if (!
#line 3902 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12854; /* aarch64_sve_uzpqvnx16si */

    case 3:
      if (!
#line 3902 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12856; /* aarch64_sve_uzpqvnx8di */

    case 4:
      if (!
#line 3902 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12858; /* aarch64_sve_uzpqvnx32bf */

    case 5:
      if (!
#line 3902 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12860; /* aarch64_sve_uzpqvnx32hf */

    case 6:
      if (!
#line 3902 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12862; /* aarch64_sve_uzpqvnx16sf */

    case 7:
      if (!
#line 3902 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12864; /* aarch64_sve_uzpqvnx8df */

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 3199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2641; /* aarch64_float_trunc_rodd_df */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 3208 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2642; /* aarch64_float_trunc_rodd_lo_v2sf */

    default:
      return -1;
    }
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern136 (x1))
    {
    case 0:
      if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10762; /* aarch64_sve_uunpkhi_vnx16qi */

    case 1:
      if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10766; /* aarch64_sve_uunpkhi_vnx8hi */

    case 2:
      if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10770; /* aarch64_sve_uunpkhi_vnx4si */

    case 3:
      if (!
#line 10036 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10912; /* aarch64_sve_punpkhi_vnx16bi */

    case 4:
      if (!
#line 10036 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10914; /* aarch64_sve_punpkhi_vnx8bi */

    case 5:
      if (!
#line 10036 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10916; /* aarch64_sve_punpkhi_vnx4bi */

    default:
      return -1;
    }
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1107 (x2))
        {
        case 0:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10851; /* *cond_float_nonextendvnx8hivnx8hf_relaxed */
          break;

        case 1:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10857; /* *cond_float_nonextendvnx4sivnx8hf_relaxed */
          break;

        case 2:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10863; /* *cond_float_nonextendvnx2divnx8hf_relaxed */
          break;

        case 3:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10853; /* *cond_float_nonextendvnx8hivnx4sf_relaxed */
          break;

        case 4:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10859; /* *cond_float_nonextendvnx4sivnx4sf_relaxed */
          break;

        case 5:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10865; /* *cond_float_nonextendvnx2divnx4sf_relaxed */
          break;

        case 6:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10855; /* *cond_float_nonextendvnx8hivnx2df_relaxed */
          break;

        case 7:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10861; /* *cond_float_nonextendvnx4sivnx2df_relaxed */
          break;

        case 8:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10867; /* *cond_float_nonextendvnx2divnx2df_relaxed */
          break;

        default:
          break;
        }
      break;

    case 1L:
      switch (pattern1108 (x2))
        {
        case 0:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10869; /* *cond_float_nonextendvnx8hivnx8hf_strict */
          break;

        case 1:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10875; /* *cond_float_nonextendvnx4sivnx8hf_strict */
          break;

        case 2:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10881; /* *cond_float_nonextendvnx2divnx8hf_strict */
          break;

        case 3:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10871; /* *cond_float_nonextendvnx8hivnx4sf_strict */
          break;

        case 4:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10877; /* *cond_float_nonextendvnx4sivnx4sf_strict */
          break;

        case 5:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10883; /* *cond_float_nonextendvnx2divnx4sf_strict */
          break;

        case 6:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10873; /* *cond_float_nonextendvnx8hivnx2df_strict */
          break;

        case 7:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10879; /* *cond_float_nonextendvnx4sivnx2df_strict */
          break;

        case 8:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10885; /* *cond_float_nonextendvnx2divnx2df_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
      || pattern1106 (x2, 
E_VNx4SImode, 
E_VNx2DFmode) != 0
      || !
#line 9703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
    return -1;
  return 10887; /* *cond_float_extendvnx4sivnx2df */
}

 int
recog_205 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern856 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7206; /* *cond_ceilvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7272; /* *cond_ceilvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7217; /* *cond_ceilvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7283; /* *cond_ceilvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7228; /* *cond_ceilvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7294; /* *cond_ceilvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7239; /* *cond_ceilvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7305; /* *cond_ceilvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7250; /* *cond_ceilvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7316; /* *cond_ceilvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7261; /* *cond_ceilvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7327; /* *cond_ceilvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11614; /* *cond_uqrshlvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11659; /* *cond_uqrshlvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11699; /* *cond_uqrshlvnx8hi_any */
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11634; /* *cond_srshlvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11676; /* *cond_srshlvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11716; /* *cond_srshlvnx2di_any */
}

 int
recog_245 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11608; /* *cond_sqrshlvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11654; /* *cond_sqrshlvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11694; /* *cond_sqrshlvnx8hi_any */
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1086 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8500; /* *cond_addvnx8bf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8646; /* *cond_addvnx8bf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8750; /* *cond_addvnx8bf_any_relaxed */

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8513; /* *cond_addvnx8hf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8659; /* *cond_addvnx8hf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8763; /* *cond_addvnx8hf_any_relaxed */

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8526; /* *cond_addvnx4sf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8672; /* *cond_addvnx4sf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8776; /* *cond_addvnx4sf_any_relaxed */

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8539; /* *cond_addvnx2df_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8685; /* *cond_addvnx2df_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8789; /* *cond_addvnx2df_any_relaxed */

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8899; /* *cond_addvnx8hf_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5829 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8905; /* *cond_addvnx8hf_any_const_relaxed */

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8900; /* *cond_addvnx4sf_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5829 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8906; /* *cond_addvnx4sf_any_const_relaxed */

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8901; /* *cond_addvnx2df_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5829 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8907; /* *cond_addvnx2df_any_const_relaxed */

        default:
          return -1;
        }

    case 1L:
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern1086 (x2))
        {
        case 0:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8552; /* *cond_addvnx8bf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8698; /* *cond_addvnx8bf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8802; /* *cond_addvnx8bf_any_strict */

        case 1:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8565; /* *cond_addvnx8hf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8711; /* *cond_addvnx8hf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8815; /* *cond_addvnx8hf_any_strict */

        case 2:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8578; /* *cond_addvnx4sf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8724; /* *cond_addvnx4sf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8828; /* *cond_addvnx4sf_any_strict */

        case 3:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8591; /* *cond_addvnx2df_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8737; /* *cond_addvnx2df_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8841; /* *cond_addvnx2df_any_strict */

        case 4:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8902; /* *cond_addvnx8hf_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8908; /* *cond_addvnx8hf_any_const_strict */

        case 5:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8903; /* *cond_addvnx4sf_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8909; /* *cond_addvnx4sf_any_const_strict */

        case 6:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8904; /* *cond_addvnx2df_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8910; /* *cond_addvnx2df_any_const_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      x2 = XEXP (x1, 1);
      if (pattern1111 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9170; /* *cond_fnmavnx16qi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9180; /* *cond_fnmavnx16qi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx16QImode)
          || !
#line 7261 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9190; /* *cond_fnmavnx16qi_any */

    case E_VNx8QImode:
      x2 = XEXP (x1, 1);
      if (pattern1111 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9171; /* *cond_fnmavnx8qi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9181; /* *cond_fnmavnx8qi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8QImode)
          || !
#line 7261 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9191; /* *cond_fnmavnx8qi_any */

    case E_VNx4QImode:
      x2 = XEXP (x1, 1);
      if (pattern1111 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9172; /* *cond_fnmavnx4qi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9182; /* *cond_fnmavnx4qi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4QImode)
          || !
#line 7261 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9192; /* *cond_fnmavnx4qi_any */

    case E_VNx2QImode:
      x2 = XEXP (x1, 1);
      if (pattern1111 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9173; /* *cond_fnmavnx2qi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9183; /* *cond_fnmavnx2qi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2QImode)
          || !
#line 7261 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9193; /* *cond_fnmavnx2qi_any */

    case E_VNx8HImode:
      x2 = XEXP (x1, 1);
      if (pattern1111 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9174; /* *cond_fnmavnx8hi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9184; /* *cond_fnmavnx8hi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HImode)
          || !
#line 7261 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9194; /* *cond_fnmavnx8hi_any */

    case E_VNx4HImode:
      x2 = XEXP (x1, 1);
      if (pattern1111 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9175; /* *cond_fnmavnx4hi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9185; /* *cond_fnmavnx4hi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4HImode)
          || !
#line 7261 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9195; /* *cond_fnmavnx4hi_any */

    case E_VNx2HImode:
      x2 = XEXP (x1, 1);
      if (pattern1111 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9176; /* *cond_fnmavnx2hi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9186; /* *cond_fnmavnx2hi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2HImode)
          || !
#line 7261 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9196; /* *cond_fnmavnx2hi_any */

    case E_VNx4SImode:
      x2 = XEXP (x1, 1);
      if (pattern1111 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9177; /* *cond_fnmavnx4si_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9187; /* *cond_fnmavnx4si_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SImode)
          || !
#line 7261 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9197; /* *cond_fnmavnx4si_any */

    case E_VNx2SImode:
      x2 = XEXP (x1, 1);
      if (pattern1111 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9178; /* *cond_fnmavnx2si_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9188; /* *cond_fnmavnx2si_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2SImode)
          || !
#line 7261 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9198; /* *cond_fnmavnx2si_any */

    case E_VNx2DImode:
      x2 = XEXP (x1, 1);
      if (pattern1111 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9179; /* *cond_fnmavnx2di_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9189; /* *cond_fnmavnx2di_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DImode)
          || !
#line 7261 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9199; /* *cond_fnmavnx2di_any */

    default:
      return -1;
    }
}

 int
recog_275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern597 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7453; /* *cond_ashrvnx16qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7623; /* *cond_ashrvnx16qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7793; /* *cond_ashrvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7470; /* *cond_ashrvnx8qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7640; /* *cond_ashrvnx8qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7810; /* *cond_ashrvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7487; /* *cond_ashrvnx4qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7657; /* *cond_ashrvnx4qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7827; /* *cond_ashrvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7504; /* *cond_ashrvnx2qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7674; /* *cond_ashrvnx2qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7844; /* *cond_ashrvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7521; /* *cond_ashrvnx8hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7691; /* *cond_ashrvnx8hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7861; /* *cond_ashrvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7538; /* *cond_ashrvnx4hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7708; /* *cond_ashrvnx4hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7878; /* *cond_ashrvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7555; /* *cond_ashrvnx2hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7725; /* *cond_ashrvnx2hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7895; /* *cond_ashrvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7572; /* *cond_ashrvnx4si_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7742; /* *cond_ashrvnx4si_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7912; /* *cond_ashrvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7589; /* *cond_ashrvnx2si_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7759; /* *cond_ashrvnx2si_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7929; /* *cond_ashrvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7606; /* *cond_ashrvnx2di_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7776; /* *cond_ashrvnx2di_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7946; /* *cond_ashrvnx2di_any */

    case 10:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8262; /* *cond_ashrvnx16qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8292; /* *cond_ashrvnx16qi_any_const */

    case 11:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8265; /* *cond_ashrvnx8qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8295; /* *cond_ashrvnx8qi_any_const */

    case 12:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8268; /* *cond_ashrvnx4qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8298; /* *cond_ashrvnx4qi_any_const */

    case 13:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8271; /* *cond_ashrvnx2qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8301; /* *cond_ashrvnx2qi_any_const */

    case 14:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8274; /* *cond_ashrvnx8hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8304; /* *cond_ashrvnx8hi_any_const */

    case 15:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8277; /* *cond_ashrvnx4hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8307; /* *cond_ashrvnx4hi_any_const */

    case 16:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8280; /* *cond_ashrvnx2hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8310; /* *cond_ashrvnx2hi_any_const */

    case 17:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8283; /* *cond_ashrvnx4si_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8313; /* *cond_ashrvnx4si_any_const */

    case 18:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8286; /* *cond_ashrvnx2si_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8316; /* *cond_ashrvnx2si_any_const */

    case 19:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8289; /* *cond_ashrvnx2di_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8319; /* *cond_ashrvnx2di_any_const */

    default:
      return -1;
    }
}

 int
recog_276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern597 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7454; /* *cond_lshrvnx16qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7624; /* *cond_lshrvnx16qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7794; /* *cond_lshrvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7471; /* *cond_lshrvnx8qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7641; /* *cond_lshrvnx8qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7811; /* *cond_lshrvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7488; /* *cond_lshrvnx4qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7658; /* *cond_lshrvnx4qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7828; /* *cond_lshrvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7505; /* *cond_lshrvnx2qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7675; /* *cond_lshrvnx2qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7845; /* *cond_lshrvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7522; /* *cond_lshrvnx8hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7692; /* *cond_lshrvnx8hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7862; /* *cond_lshrvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7539; /* *cond_lshrvnx4hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7709; /* *cond_lshrvnx4hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7879; /* *cond_lshrvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7556; /* *cond_lshrvnx2hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7726; /* *cond_lshrvnx2hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7896; /* *cond_lshrvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7573; /* *cond_lshrvnx4si_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7743; /* *cond_lshrvnx4si_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7913; /* *cond_lshrvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7590; /* *cond_lshrvnx2si_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7760; /* *cond_lshrvnx2si_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7930; /* *cond_lshrvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7607; /* *cond_lshrvnx2di_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7777; /* *cond_lshrvnx2di_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7947; /* *cond_lshrvnx2di_any */

    case 10:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8263; /* *cond_lshrvnx16qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8293; /* *cond_lshrvnx16qi_any_const */

    case 11:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8266; /* *cond_lshrvnx8qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8296; /* *cond_lshrvnx8qi_any_const */

    case 12:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8269; /* *cond_lshrvnx4qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8299; /* *cond_lshrvnx4qi_any_const */

    case 13:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8272; /* *cond_lshrvnx2qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8302; /* *cond_lshrvnx2qi_any_const */

    case 14:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8275; /* *cond_lshrvnx8hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8305; /* *cond_lshrvnx8hi_any_const */

    case 15:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8278; /* *cond_lshrvnx4hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8308; /* *cond_lshrvnx4hi_any_const */

    case 16:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8281; /* *cond_lshrvnx2hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8311; /* *cond_lshrvnx2hi_any_const */

    case 17:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8284; /* *cond_lshrvnx4si_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8314; /* *cond_lshrvnx4si_any_const */

    case 18:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8287; /* *cond_lshrvnx2si_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8317; /* *cond_lshrvnx2si_any_const */

    case 19:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8290; /* *cond_lshrvnx2di_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8320; /* *cond_lshrvnx2di_any_const */

    default:
      return -1;
    }
}

 int
recog_286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern720 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7450; /* *cond_sminvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7620; /* *cond_sminvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7790; /* *cond_sminvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7467; /* *cond_sminvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7637; /* *cond_sminvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7807; /* *cond_sminvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7484; /* *cond_sminvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7654; /* *cond_sminvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7824; /* *cond_sminvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7501; /* *cond_sminvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7671; /* *cond_sminvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7841; /* *cond_sminvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7518; /* *cond_sminvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7688; /* *cond_sminvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7858; /* *cond_sminvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7535; /* *cond_sminvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7705; /* *cond_sminvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7875; /* *cond_sminvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7552; /* *cond_sminvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7722; /* *cond_sminvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7892; /* *cond_sminvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7569; /* *cond_sminvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7739; /* *cond_sminvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7909; /* *cond_sminvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7586; /* *cond_sminvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7756; /* *cond_sminvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7926; /* *cond_sminvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7603; /* *cond_sminvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7773; /* *cond_sminvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7943; /* *cond_sminvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_296 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case VEC_DUPLICATE:
          return recog_272 (x1, insn, pnum_clobbers);

        case ABS:
          switch (pattern595 (x3))
            {
            case 0:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6702; /* *cond_absvnx16qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6792; /* *cond_absvnx16qi_any */

            case 1:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6711; /* *cond_absvnx8qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6801; /* *cond_absvnx8qi_any */

            case 2:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6720; /* *cond_absvnx4qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6810; /* *cond_absvnx4qi_any */

            case 3:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6729; /* *cond_absvnx2qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6819; /* *cond_absvnx2qi_any */

            case 4:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6738; /* *cond_absvnx8hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6828; /* *cond_absvnx8hi_any */

            case 5:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6747; /* *cond_absvnx4hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6837; /* *cond_absvnx4hi_any */

            case 6:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6756; /* *cond_absvnx2hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6846; /* *cond_absvnx2hi_any */

            case 7:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6765; /* *cond_absvnx4si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6855; /* *cond_absvnx4si_any */

            case 8:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6774; /* *cond_absvnx2si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6864; /* *cond_absvnx2si_any */

            case 9:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6783; /* *cond_absvnx2di_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6873; /* *cond_absvnx2di_any */

            default:
              return -1;
            }

        case NEG:
          switch (pattern595 (x3))
            {
            case 0:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6703; /* *cond_negvnx16qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6793; /* *cond_negvnx16qi_any */

            case 1:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6712; /* *cond_negvnx8qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6802; /* *cond_negvnx8qi_any */

            case 2:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6721; /* *cond_negvnx4qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6811; /* *cond_negvnx4qi_any */

            case 3:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6730; /* *cond_negvnx2qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6820; /* *cond_negvnx2qi_any */

            case 4:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6739; /* *cond_negvnx8hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6829; /* *cond_negvnx8hi_any */

            case 5:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6748; /* *cond_negvnx4hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6838; /* *cond_negvnx4hi_any */

            case 6:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6757; /* *cond_negvnx2hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6847; /* *cond_negvnx2hi_any */

            case 7:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6766; /* *cond_negvnx4si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6856; /* *cond_negvnx4si_any */

            case 8:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6775; /* *cond_negvnx2si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6865; /* *cond_negvnx2si_any */

            case 9:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6784; /* *cond_negvnx2di_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6874; /* *cond_negvnx2di_any */

            default:
              return -1;
            }

        case NOT:
          switch (pattern595 (x3))
            {
            case 0:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6704; /* *cond_one_cmplvnx16qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6794; /* *cond_one_cmplvnx16qi_any */

            case 1:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6713; /* *cond_one_cmplvnx8qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6803; /* *cond_one_cmplvnx8qi_any */

            case 2:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6722; /* *cond_one_cmplvnx4qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6812; /* *cond_one_cmplvnx4qi_any */

            case 3:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6731; /* *cond_one_cmplvnx2qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6821; /* *cond_one_cmplvnx2qi_any */

            case 4:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6740; /* *cond_one_cmplvnx8hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6830; /* *cond_one_cmplvnx8hi_any */

            case 5:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6749; /* *cond_one_cmplvnx4hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6839; /* *cond_one_cmplvnx4hi_any */

            case 6:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6758; /* *cond_one_cmplvnx2hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6848; /* *cond_one_cmplvnx2hi_any */

            case 7:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6767; /* *cond_one_cmplvnx4si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6857; /* *cond_one_cmplvnx4si_any */

            case 8:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6776; /* *cond_one_cmplvnx2si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6866; /* *cond_one_cmplvnx2si_any */

            case 9:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6785; /* *cond_one_cmplvnx2di_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6875; /* *cond_one_cmplvnx2di_any */

            default:
              return -1;
            }

        case CLRSB:
          return recog_295 (x1, insn, pnum_clobbers);

        case CLZ:
          return recog_294 (x1, insn, pnum_clobbers);

        case POPCOUNT:
          return recog_293 (x1, insn, pnum_clobbers);

        case BITREVERSE:
          return recog_292 (x1, insn, pnum_clobbers);

        case SS_ABS:
          return recog_290 (x1, insn, pnum_clobbers);

        case SS_NEG:
          return recog_291 (x1, insn, pnum_clobbers);

        case UNSPEC:
          return recog_277 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != TRUNCATE)
            return -1;
          operands[1] = x4;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          x6 = XVECEXP (x3, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              switch (pattern982 (x3, 
E_VNx8HImode, 
E_VNx8BImode))
                {
                case 0:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x81) == 0))
                    return -1;
                  return 7053; /* aarch64_cond_sxtvnx8hivnx8qi */

                case 1:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x41) == 0))
                    return -1;
                  return 7054; /* aarch64_cond_sxtvnx8hivnx4qi */

                case 2:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x21) == 0))
                    return -1;
                  return 7055; /* aarch64_cond_sxtvnx8hivnx2qi */

                case 3:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x42) == 0))
                    return -1;
                  return 7056; /* aarch64_cond_sxtvnx8hivnx4hi */

                case 4:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x22) == 0))
                    return -1;
                  return 7057; /* aarch64_cond_sxtvnx8hivnx2hi */

                case 5:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x24) == 0))
                    return -1;
                  return 7058; /* aarch64_cond_sxtvnx8hivnx2si */

                default:
                  return -1;
                }

            case E_VNx4SImode:
              switch (pattern982 (x3, 
E_VNx4SImode, 
E_VNx4BImode))
                {
                case 0:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x81) == 0))
                    return -1;
                  return 7059; /* aarch64_cond_sxtvnx4sivnx8qi */

                case 1:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x41) == 0))
                    return -1;
                  return 7060; /* aarch64_cond_sxtvnx4sivnx4qi */

                case 2:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x21) == 0))
                    return -1;
                  return 7061; /* aarch64_cond_sxtvnx4sivnx2qi */

                case 3:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x42) == 0))
                    return -1;
                  return 7062; /* aarch64_cond_sxtvnx4sivnx4hi */

                case 4:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x22) == 0))
                    return -1;
                  return 7063; /* aarch64_cond_sxtvnx4sivnx2hi */

                case 5:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x24) == 0))
                    return -1;
                  return 7064; /* aarch64_cond_sxtvnx4sivnx2si */

                default:
                  return -1;
                }

            case E_VNx2DImode:
              switch (pattern982 (x3, 
E_VNx2DImode, 
E_VNx2BImode))
                {
                case 0:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x81) == 0))
                    return -1;
                  return 7065; /* aarch64_cond_sxtvnx2divnx8qi */

                case 1:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x41) == 0))
                    return -1;
                  return 7066; /* aarch64_cond_sxtvnx2divnx4qi */

                case 2:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x21) == 0))
                    return -1;
                  return 7067; /* aarch64_cond_sxtvnx2divnx2qi */

                case 3:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x42) == 0))
                    return -1;
                  return 7068; /* aarch64_cond_sxtvnx2divnx4hi */

                case 4:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x22) == 0))
                    return -1;
                  return 7069; /* aarch64_cond_sxtvnx2divnx2hi */

                case 5:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x24) == 0))
                    return -1;
                  return 7070; /* aarch64_cond_sxtvnx2divnx2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          return recog_271 (x1, insn, pnum_clobbers);

        case PLUS:
          return recog_273 (x1, insn, pnum_clobbers);

        case MINUS:
          return recog_270 (x1, insn, pnum_clobbers);

        case MULT:
          return recog_289 (x1, insn, pnum_clobbers);

        case SMAX:
          return recog_288 (x1, insn, pnum_clobbers);

        case UMAX:
          return recog_287 (x1, insn, pnum_clobbers);

        case SMIN:
          return recog_286 (x1, insn, pnum_clobbers);

        case UMIN:
          return recog_285 (x1, insn, pnum_clobbers);

        case ASHIFT:
          return recog_274 (x1, insn, pnum_clobbers);

        case ASHIFTRT:
          return recog_275 (x1, insn, pnum_clobbers);

        case LSHIFTRT:
          return recog_276 (x1, insn, pnum_clobbers);

        case IOR:
          return recog_284 (x1, insn, pnum_clobbers);

        case XOR:
          return recog_283 (x1, insn, pnum_clobbers);

        case SS_PLUS:
          return recog_282 (x1, insn, pnum_clobbers);

        case US_PLUS:
          return recog_281 (x1, insn, pnum_clobbers);

        case SS_MINUS:
          return recog_280 (x1, insn, pnum_clobbers);

        case US_MINUS:
          return recog_279 (x1, insn, pnum_clobbers);

        case DIV:
          switch (pattern598 (x3))
            {
            case 0:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 4645 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8129; /* *cond_divvnx4si_2 */
              if (rtx_equal_p (x6, operands[3])
                  && 
#line 4662 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8133; /* *cond_divvnx4si_3 */
              operands[4] = x6;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 4679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8137; /* *cond_divvnx4si_any */

            case 1:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 4645 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8131; /* *cond_divvnx2di_2 */
              if (rtx_equal_p (x6, operands[3])
                  && 
#line 4662 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8135; /* *cond_divvnx2di_3 */
              operands[4] = x6;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 4679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8139; /* *cond_divvnx2di_any */

            default:
              return -1;
            }

        case UDIV:
          switch (pattern598 (x3))
            {
            case 0:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 4645 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8130; /* *cond_udivvnx4si_2 */
              if (rtx_equal_p (x6, operands[3])
                  && 
#line 4662 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8134; /* *cond_udivvnx4si_3 */
              operands[4] = x6;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 4679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8138; /* *cond_udivvnx4si_any */

            case 1:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 4645 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8132; /* *cond_udivvnx2di_2 */
              if (rtx_equal_p (x6, operands[3])
                  && 
#line 4662 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8136; /* *cond_udivvnx2di_3 */
              operands[4] = x6;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 4679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8140; /* *cond_udivvnx2di_any */

            default:
              return -1;
            }

        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
          return recog_278 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 126)
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x4, 0, 2);
      if (GET_CODE (x10) != EQ)
        return -1;
      x11 = XVECEXP (x4, 0, 0);
      operands[1] = x11;
      x12 = XEXP (x10, 0);
      operands[2] = x12;
      x13 = XEXP (x10, 1);
      operands[3] = x13;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x3, 0, 2);
      if (!rtx_equal_p (x6, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1186 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7127; /* *cnotvnx16qi */

        case E_VNx8QImode:
          if (pattern1186 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7128; /* *cnotvnx8qi */

        case E_VNx4QImode:
          if (pattern1186 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7129; /* *cnotvnx4qi */

        case E_VNx2QImode:
          if (pattern1186 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7130; /* *cnotvnx2qi */

        case E_VNx8HImode:
          if (pattern1186 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7131; /* *cnotvnx8hi */

        case E_VNx4HImode:
          if (pattern1186 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7132; /* *cnotvnx4hi */

        case E_VNx2HImode:
          if (pattern1186 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7133; /* *cnotvnx2hi */

        case E_VNx4SImode:
          if (pattern1186 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7134; /* *cnotvnx4si */

        case E_VNx2SImode:
          if (pattern1186 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7135; /* *cnotvnx2si */

        case E_VNx2DImode:
          if (pattern1186 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7136; /* *cnotvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_398 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          switch (pattern1153 (
E_V8QImode))
            {
            case 0:
              if (!
#line 9856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (8)))
                return -1;
              return 5294; /* aarch64_lutv8qiv8qi */

            case 1:
              if (!
#line 9856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (8)))
                return -1;
              return 5299; /* aarch64_lutv8qiv16qi */

            default:
              return -1;
            }

        case E_V16QImode:
          switch (pattern1153 (
E_V16QImode))
            {
            case 0:
              if (!
#line 9856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (16)))
                return -1;
              return 5295; /* aarch64_lutv16qiv8qi */

            case 1:
              if (!
#line 9856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (16)))
                return -1;
              return 5300; /* aarch64_lutv16qiv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          switch (pattern1153 (
E_V4HImode))
            {
            case 0:
              if (!
#line 9856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5296; /* aarch64_lutv4hiv8qi */

            case 1:
              if (!
#line 9856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5301; /* aarch64_lutv4hiv16qi */

            default:
              return -1;
            }

        case E_V2x8HImode:
          switch (pattern1153 (
E_V2x8HImode))
            {
            case 0:
              if (!
#line 9869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5304; /* aarch64_lutv2x8hiv8qi */

            case 1:
              if (!
#line 9869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5307; /* aarch64_lutv2x8hiv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          switch (pattern1153 (
E_V4HFmode))
            {
            case 0:
              if (!
#line 9856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5297; /* aarch64_lutv4hfv8qi */

            case 1:
              if (!
#line 9856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5302; /* aarch64_lutv4hfv16qi */

            default:
              return -1;
            }

        case E_V2x8HFmode:
          switch (pattern1153 (
E_V2x8HFmode))
            {
            case 0:
              if (!
#line 9869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5305; /* aarch64_lutv2x8hfv8qi */

            case 1:
              if (!
#line 9869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5308; /* aarch64_lutv2x8hfv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4BFmode:
          switch (pattern1153 (
E_V4BFmode))
            {
            case 0:
              if (!
#line 9856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5298; /* aarch64_lutv4bfv8qi */

            case 1:
              if (!
#line 9856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5303; /* aarch64_lutv4bfv16qi */

            default:
              return -1;
            }

        case E_V2x8BFmode:
          switch (pattern1153 (
E_V2x8BFmode))
            {
            case 0:
              if (!
#line 9869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5306; /* aarch64_lutv2x8bfv8qi */

            case 1:
              if (!
#line 9869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5309; /* aarch64_lutv2x8bfv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_407 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern222 (x1))
    {
    case 0:
      if (!
#line 1184 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13360; /* aarch64_sme_faddvnx8sf */

    case 1:
      if (!
#line 1184 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13362; /* aarch64_sme_faddvnx16sf */

    case 2:
      if (!(
#line 1184 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 714 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13364; /* aarch64_sme_faddvnx4df */

    case 3:
      if (!(
#line 1184 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 715 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13366; /* aarch64_sme_faddvnx8df */

    case 4:
      if (!(
#line 1184 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 716 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13368; /* aarch64_sme_faddvnx16hf */

    case 5:
      if (!(
#line 1184 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 717 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13370; /* aarch64_sme_faddvnx32hf */

    case 6:
      if (!(
#line 1184 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 718 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13372; /* aarch64_sme_faddvnx16bf */

    case 7:
      if (!(
#line 1184 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 719 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13374; /* aarch64_sme_faddvnx32bf */

    case 8:
      if (!
#line 1197 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13376; /* *aarch64_sme_faddvnx8sf_plus */

    case 9:
      if (!
#line 1197 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13378; /* *aarch64_sme_faddvnx16sf_plus */

    case 10:
      if (!(
#line 1197 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 714 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13380; /* *aarch64_sme_faddvnx4df_plus */

    case 11:
      if (!(
#line 1197 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 715 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13382; /* *aarch64_sme_faddvnx8df_plus */

    case 12:
      if (!(
#line 1197 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 716 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13384; /* *aarch64_sme_faddvnx16hf_plus */

    case 13:
      if (!(
#line 1197 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 717 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13386; /* *aarch64_sme_faddvnx32hf_plus */

    case 14:
      if (!(
#line 1197 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 718 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13388; /* *aarch64_sme_faddvnx16bf_plus */

    case 15:
      if (!(
#line 1197 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 719 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13390; /* *aarch64_sme_faddvnx32bf_plus */

    default:
      return -1;
    }
}

 int
recog_418 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (pattern185 (x2, 
E_V8QImode, 
E_V4HFmode) != 0
          || !
#line 199 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT2))
        return -1;
      return 5328; /* aarch64_fdotv4hf */

    case E_V8HFmode:
      if (pattern185 (x2, 
E_V16QImode, 
E_V8HFmode) != 0
          || !
#line 200 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT2))
        return -1;
      return 5329; /* aarch64_fdotv8hf */

    case E_V2SFmode:
      if (pattern185 (x2, 
E_V8QImode, 
E_V2SFmode) != 0
          || !
#line 201 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT4))
        return -1;
      return 5330; /* aarch64_fdotv2sf */

    case E_V4SFmode:
      if (pattern185 (x2, 
E_V16QImode, 
E_V4SFmode) != 0
          || !
#line 202 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT4))
        return -1;
      return 5331; /* aarch64_fdotv4sf */

    default:
      return -1;
    }
}

 int
recog_424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern221 (x1))
    {
    case 0:
      if (!
#line 1159 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13344; /* aarch64_sme_addvnx8si */

    case 1:
      if (!(
#line 1159 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 710 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13346; /* aarch64_sme_addvnx4di */

    case 2:
      if (!
#line 1159 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13348; /* aarch64_sme_addvnx16si */

    case 3:
      if (!(
#line 1159 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 711 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13350; /* aarch64_sme_addvnx8di */

    case 4:
      if (!
#line 1172 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13352; /* *aarch64_sme_addvnx8si_plus */

    case 5:
      if (!(
#line 1172 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 710 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13354; /* *aarch64_sme_addvnx4di_plus */

    case 6:
      if (!
#line 1172 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13356; /* *aarch64_sme_addvnx16si_plus */

    case 7:
      if (!(
#line 1172 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 711 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13358; /* *aarch64_sme_addvnx8di_plus */

    default:
      return -1;
    }
}

 int
recog_432 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pattern62 (x1, 
E_VNx4SImode, 
93, 
89) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 3);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16BFmode:
              if (!aligned_register_operand (operands[1], E_VNx16BFmode)
                  || !aligned_register_operand (operands[2], E_VNx16BFmode)
                  || !
#line 1768 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13866; /* aarch64_sme_fdotvnx4sivnx16bf */

            case E_VNx32BFmode:
              if (!aligned_register_operand (operands[1], E_VNx32BFmode)
                  || !aligned_register_operand (operands[2], E_VNx32BFmode)
                  || !
#line 1768 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13867; /* aarch64_sme_fdotvnx4sivnx32bf */

            case E_VNx16HFmode:
              if (!aligned_register_operand (operands[1], E_VNx16HFmode)
                  || !aligned_register_operand (operands[2], E_VNx16HFmode)
                  || !
#line 1768 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13868; /* aarch64_sme_fdotvnx4sivnx16hf */

            case E_VNx32HFmode:
              if (!aligned_register_operand (operands[1], E_VNx32HFmode)
                  || !aligned_register_operand (operands[2], E_VNx32HFmode)
                  || !
#line 1768 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13869; /* aarch64_sme_fdotvnx4sivnx32hf */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (pattern247 (x5))
            {
            case 0:
              if (!
#line 1796 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13874; /* aarch64_sme_single_fdotvnx4sivnx16bf */

            case 1:
              if (!
#line 1796 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13875; /* aarch64_sme_single_fdotvnx4sivnx32bf */

            case 2:
              if (!
#line 1796 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13876; /* aarch64_sme_single_fdotvnx4sivnx16hf */

            case 3:
              if (!
#line 1796 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13877; /* aarch64_sme_single_fdotvnx4sivnx32hf */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 167)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          operands[2] = x7;
          x8 = XVECEXP (x5, 0, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1327 (x5))
            {
            case 0:
              if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13882; /* aarch64_sme_lane_fdotvnx4sivnx16bf */

            case 1:
              if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13884; /* aarch64_sme_lane_fdotvnx4sivnx32bf */

            case 2:
              if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13886; /* aarch64_sme_lane_fdotvnx4sivnx16hf */

            case 3:
              if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13888; /* aarch64_sme_lane_fdotvnx4sivnx32hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[1] = x10;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 3);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[3] = x5;
          switch (pattern1311 ())
            {
            case 0:
              if (!
#line 1782 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13870; /* *aarch64_sme_fdotvnx4sivnx16bf_plus */

            case 1:
              if (!
#line 1782 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13871; /* *aarch64_sme_fdotvnx4sivnx32bf_plus */

            case 2:
              if (!
#line 1782 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13872; /* *aarch64_sme_fdotvnx4sivnx16hf_plus */

            case 3:
              if (!
#line 1782 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13873; /* *aarch64_sme_fdotvnx4sivnx32hf_plus */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          switch (pattern251 (x5))
            {
            case 0:
              if (!
#line 1811 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13878; /* *aarch64_sme_single_fdotvnx4sivnx16bf_plus */

            case 1:
              if (!
#line 1811 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13879; /* *aarch64_sme_single_fdotvnx4sivnx32bf_plus */

            case 2:
              if (!
#line 1811 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13880; /* *aarch64_sme_single_fdotvnx4sivnx16hf_plus */

            case 3:
              if (!
#line 1811 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13881; /* *aarch64_sme_single_fdotvnx4sivnx32hf_plus */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 167)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          operands[3] = x7;
          x8 = XVECEXP (x5, 0, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (pattern1340 (x5))
            {
            case 0:
              if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13890; /* *aarch64_sme_lane_fdotvnx4sivnx16bf_plus */

            case 1:
              if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13892; /* *aarch64_sme_lane_fdotvnx4sivnx32bf_plus */

            case 2:
              if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13894; /* *aarch64_sme_lane_fdotvnx4sivnx16hf_plus */

            case 3:
              if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13896; /* *aarch64_sme_lane_fdotvnx4sivnx32hf_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_434 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern243 (x1))
    {
    case 0:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13424; /* aarch64_sme_sdotvnx4sivnx32qi */

    case 1:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13427; /* aarch64_sme_sdotvnx4sivnx64qi */

    case 2:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13430; /* aarch64_sme_sdotvnx4sivnx16hi */

    case 3:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13433; /* aarch64_sme_sdotvnx4sivnx32hi */

    case 4:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13436; /* aarch64_sme_sdotvnx2divnx32qi */

    case 5:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13439; /* aarch64_sme_sdotvnx2divnx64qi */

    case 6:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13442; /* aarch64_sme_sdotvnx2divnx16hi */

    case 7:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13445; /* aarch64_sme_sdotvnx2divnx32hi */

    case 8:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13472; /* aarch64_sme_single_sdotvnx4sivnx32qi */

    case 9:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13475; /* aarch64_sme_single_sdotvnx4sivnx64qi */

    case 10:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13478; /* aarch64_sme_single_sdotvnx4sivnx16hi */

    case 11:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13481; /* aarch64_sme_single_sdotvnx4sivnx32hi */

    case 12:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13484; /* aarch64_sme_single_sdotvnx2divnx32qi */

    case 13:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13487; /* aarch64_sme_single_sdotvnx2divnx64qi */

    case 14:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13490; /* aarch64_sme_single_sdotvnx2divnx16hi */

    case 15:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13493; /* aarch64_sme_single_sdotvnx2divnx32hi */

    case 16:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13524; /* aarch64_sme_lane_sdotvnx4sivnx32qi */

    case 17:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13532; /* aarch64_sme_lane_sdotvnx4sivnx64qi */

    case 18:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13540; /* aarch64_sme_lane_sdotvnx4sivnx16hi */

    case 19:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13548; /* aarch64_sme_lane_sdotvnx4sivnx32hi */

    case 20:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13556; /* aarch64_sme_lane_sdotvnx2divnx32qi */

    case 21:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13564; /* aarch64_sme_lane_sdotvnx2divnx64qi */

    case 22:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13572; /* aarch64_sme_lane_sdotvnx2divnx16hi */

    case 23:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13580; /* aarch64_sme_lane_sdotvnx2divnx32hi */

    case 24:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13448; /* *aarch64_sme_sdotvnx4sivnx32qi_plus */

    case 25:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13451; /* *aarch64_sme_sdotvnx4sivnx64qi_plus */

    case 26:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13454; /* *aarch64_sme_sdotvnx4sivnx16hi_plus */

    case 27:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13457; /* *aarch64_sme_sdotvnx4sivnx32hi_plus */

    case 28:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13460; /* *aarch64_sme_sdotvnx2divnx32qi_plus */

    case 29:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13463; /* *aarch64_sme_sdotvnx2divnx64qi_plus */

    case 30:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13466; /* *aarch64_sme_sdotvnx2divnx16hi_plus */

    case 31:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13469; /* *aarch64_sme_sdotvnx2divnx32hi_plus */

    case 32:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13496; /* *aarch64_sme_single_sdotvnx4sivnx32qi_plus */

    case 33:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13499; /* *aarch64_sme_single_sdotvnx4sivnx64qi_plus */

    case 34:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13502; /* *aarch64_sme_single_sdotvnx4sivnx16hi_plus */

    case 35:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13505; /* *aarch64_sme_single_sdotvnx4sivnx32hi_plus */

    case 36:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13508; /* *aarch64_sme_single_sdotvnx2divnx32qi_plus */

    case 37:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13511; /* *aarch64_sme_single_sdotvnx2divnx64qi_plus */

    case 38:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13514; /* *aarch64_sme_single_sdotvnx2divnx16hi_plus */

    case 39:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13517; /* *aarch64_sme_single_sdotvnx2divnx32hi_plus */

    case 40:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13588; /* *aarch64_sme_lane_sdotvnx4sivnx32qi_plus */

    case 41:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13596; /* *aarch64_sme_lane_sdotvnx4sivnx64qi_plus */

    case 42:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13604; /* *aarch64_sme_lane_sdotvnx4sivnx16hi_plus */

    case 43:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13612; /* *aarch64_sme_lane_sdotvnx4sivnx32hi_plus */

    case 44:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13620; /* *aarch64_sme_lane_sdotvnx2divnx32qi_plus */

    case 45:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13628; /* *aarch64_sme_lane_sdotvnx2divnx64qi_plus */

    case 46:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13636; /* *aarch64_sme_lane_sdotvnx2divnx16hi_plus */

    case 47:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13644; /* *aarch64_sme_lane_sdotvnx2divnx32hi_plus */

    default:
      return -1;
    }
}

 int
recog_449 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  operands[1] = x3;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      switch (pattern937 (x4, 
E_SImode))
        {
        case 0:
          if (!
#line 6384 "../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32))
            return -1;
          return 814; /* *aarch64_bfisihi_16 */

        case 1:
          if (!
#line 6384 "../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32))
            return -1;
          return 818; /* *aarch64_bfisisi_16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern937 (x4, 
E_DImode))
        {
        case 0:
          if (!
#line 6384 "../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
            return -1;
          return 816; /* *aarch64_bfidihi_16 */

        case 1:
          if (!
#line 6384 "../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
            return -1;
          return 821; /* *aarch64_bfidisi_16 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_450 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!cc_register (operands[2], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[3] = x8;
  if (!aarch64_reg_zero_or_m1_or_1 (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x3, 2);
  operands[4] = x9;
  if (!aarch64_reg_zero_or_m1_or_1 (operands[4], E_SImode)
      || !
#line 4536 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
    return -1;
  return 458; /* *cmovsi_insn_uxtw */
}

 int
recog_452 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 39:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != LO_SUM
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!aarch64_valid_symref (operands[2], E_DImode)
              || !
#line 7633 "../../gcc/config/aarch64/aarch64.md"
(TARGET_ILP32))
            return -1;
          return 1114; /* ldr_got_small_28k_sidi */

        case 41:
          if (GET_MODE (x4) != E_SImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!aarch64_valid_symref (operands[1], E_DImode)
              || !
#line 7652 "../../gcc/config/aarch64/aarch64.md"
(TARGET_ILP32))
            return -1;
          return 1117; /* ldr_got_tiny_sidi */

        case 40:
          if (pattern481 (x3) != 0)
            return -1;
          return 1123; /* tlsie_small_sidi */

        case 204:
          x5 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  switch (pattern793 (x3, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2717; /* aarch64_zero_extendsi_reduc_plus_v8qi */

                    case 1:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2719; /* aarch64_zero_extendsi_reduc_plus_v16qi */

                    case 2:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2721; /* aarch64_zero_extendsi_reduc_plus_v4hi */

                    case 3:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2723; /* aarch64_zero_extendsi_reduc_plus_v8hi */

                    default:
                      return -1;
                    }

                case E_DImode:
                  switch (pattern793 (x3, 
E_DImode))
                    {
                    case 0:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2718; /* aarch64_zero_extenddi_reduc_plus_v8qi */

                    case 1:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2720; /* aarch64_zero_extenddi_reduc_plus_v16qi */

                    case 2:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2722; /* aarch64_zero_extenddi_reduc_plus_v4hi */

                    case 3:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2724; /* aarch64_zero_extenddi_reduc_plus_v8hi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern603 (x3))
                {
                case 0:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2755; /* *aarch64_saddlvv8qi_zesi */

                case 1:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2759; /* *aarch64_saddlvv16qi_zesi */

                case 2:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2763; /* *aarch64_saddlvv4hi_zesi */

                case 3:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2767; /* *aarch64_saddlvv8hi_zesi */

                case 4:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2771; /* *aarch64_saddlvv4si_zesi */

                case 5:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2775; /* *aarch64_saddlvv2si_zesi */

                case 6:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2757; /* *aarch64_saddlvv8qi_zedi */

                case 7:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2761; /* *aarch64_saddlvv16qi_zedi */

                case 8:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2765; /* *aarch64_saddlvv4hi_zedi */

                case 9:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2769; /* *aarch64_saddlvv8hi_zedi */

                case 10:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2773; /* *aarch64_saddlvv4si_zedi */

                case 11:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2777; /* *aarch64_saddlvv2si_zedi */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern603 (x3))
                {
                case 0:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2756; /* *aarch64_uaddlvv8qi_zesi */

                case 1:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2760; /* *aarch64_uaddlvv16qi_zesi */

                case 2:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2764; /* *aarch64_uaddlvv4hi_zesi */

                case 3:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2768; /* *aarch64_uaddlvv8hi_zesi */

                case 4:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2772; /* *aarch64_uaddlvv4si_zesi */

                case 5:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2776; /* *aarch64_uaddlvv2si_zesi */

                case 6:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2758; /* *aarch64_uaddlvv8qi_zedi */

                case 7:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2762; /* *aarch64_uaddlvv16qi_zedi */

                case 8:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2766; /* *aarch64_uaddlvv4hi_zedi */

                case 9:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2770; /* *aarch64_uaddlvv8hi_zedi */

                case 10:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2774; /* *aarch64_uaddlvv4si_zedi */

                case 11:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2778; /* *aarch64_uaddlvv2si_zedi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 42
          || pattern481 (x3) != 0)
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1126; /* tlsie_tiny_sidi */

    case 3:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      x10 = XVECEXP (x4, 0, 2);
      operands[3] = x10;
      switch (XINT (x4, 1))
        {
        case 168:
          if (!const_int_operand (operands[1], E_DImode)
              || !const_int_operand (operands[2], E_DImode)
              || !const_int_operand (operands[3], E_DImode)
              || !
#line 10356 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10956; /* aarch64_sve_cnt_pat */

        case 306:
          if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16BImode:
              if (!register_operand (operands[1], E_VNx16BImode)
                  || !register_operand (operands[3], E_VNx16BImode)
                  || !
#line 10678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10987; /* aarch64_pred_cntpvnx16bi */

            case E_VNx8BImode:
              if (!register_operand (operands[1], E_VNx8BImode)
                  || !register_operand (operands[3], E_VNx8BImode)
                  || !
#line 10678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10988; /* aarch64_pred_cntpvnx8bi */

            case E_VNx4BImode:
              if (!register_operand (operands[1], E_VNx4BImode)
                  || !register_operand (operands[3], E_VNx4BImode)
                  || !
#line 10678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10989; /* aarch64_pred_cntpvnx4bi */

            case E_VNx2BImode:
              if (!register_operand (operands[1], E_VNx2BImode)
                  || !register_operand (operands[3], E_VNx2BImode)
                  || !
#line 10678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10990; /* aarch64_pred_cntpvnx2bi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_455 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x3, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (XINT (x3, 1))
    {
    case 24:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          switch (pattern867 (x2, 
E_HImode))
            {
            case 0:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (HImode) > GET_MODE_SIZE (QImode)))
                return -1;
              return 5480; /* *atomic_loadqi_zexthi */

            case 1:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (HImode) > GET_MODE_SIZE (HImode)))
                return -1;
              return 5481; /* *atomic_loadhi_zexthi */

            case 2:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (HImode) > GET_MODE_SIZE (SImode)))
                return -1;
              return 5482; /* *atomic_loadsi_zexthi */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern867 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (SImode) > GET_MODE_SIZE (QImode)))
                return -1;
              return 5483; /* *atomic_loadqi_zextsi */

            case 1:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode)))
                return -1;
              return 5484; /* *atomic_loadhi_zextsi */

            case 2:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode)))
                return -1;
              return 5485; /* *atomic_loadsi_zextsi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern867 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (DImode) > GET_MODE_SIZE (QImode)))
                return -1;
              return 5486; /* *atomic_loadqi_zextdi */

            case 1:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode)))
                return -1;
              return 5487; /* *atomic_loadhi_zextdi */

            case 2:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode)))
                return -1;
              return 5488; /* *atomic_loadsi_zextdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 25:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          switch (pattern867 (x2, 
E_HImode))
            {
            case 0:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (16 > 8)))
                return -1;
              return 5497; /* *aarch64_atomic_loadqi_rcpc_zext */

            case 1:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (16 > 16)))
                return -1;
              return 5498; /* *aarch64_atomic_loadhi_rcpc_zext */

            case 2:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (16 > 32)))
                return -1;
              return 5499; /* *aarch64_atomic_loadsi_rcpc_zext */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern867 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (32 > 8)))
                return -1;
              return 5500; /* *aarch64_atomic_loadqi_rcpc_zext */

            case 1:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (32 > 16)))
                return -1;
              return 5501; /* *aarch64_atomic_loadhi_rcpc_zext */

            case 2:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (32 > 32)))
                return -1;
              return 5502; /* *aarch64_atomic_loadsi_rcpc_zext */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern867 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (64 > 8)))
                return -1;
              return 5503; /* *aarch64_atomic_loadqi_rcpc_zext */

            case 1:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (64 > 16)))
                return -1;
              return 5504; /* *aarch64_atomic_loadhi_rcpc_zext */

            case 2:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (64 > 32)))
                return -1;
              return 5505; /* *aarch64_atomic_loadsi_rcpc_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 22:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!aarch64_sync_memory_operand (operands[1], E_QImode))
            return -1;
          return 5516; /* aarch64_load_exclusiveqi */

        case E_HImode:
          if (!aarch64_sync_memory_operand (operands[1], E_HImode))
            return -1;
          return 5517; /* aarch64_load_exclusivehi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_459 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_POLY_INT:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          if (aarch64_pluslong_operand (operands[2], E_SImode))
            return 119; /* *addsi3_aarch64 */
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_SImode)
              || !
#line 2543 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx))
            return -1;
          return 122; /* *addsi3_poly_1 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (aarch64_pluslong_operand (operands[2], E_DImode))
            return 120; /* *adddi3_aarch64 */
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_DImode)
              || !
#line 2543 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx))
            return -1;
          return 123; /* *adddi3_poly_1 */

        case E_HFmode:
          if (pattern31 (x2, 
E_HFmode) != 0
              || !(
#line 7215 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return -1;
          return 1042; /* addhf3 */

        case E_SFmode:
          if (pattern31 (x2, 
E_SFmode) != 0
              || !
#line 7215 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1043; /* addsf3 */

        case E_DFmode:
          if (pattern31 (x2, 
E_DFmode) != 0
              || !
#line 7215 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1044; /* adddf3 */

        case E_V8QImode:
          if (pattern31 (x2, 
E_V8QImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1338; /* addv8qi3 */

        case E_V16QImode:
          if (pattern31 (x2, 
E_V16QImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1341; /* addv16qi3 */

        case E_V4HImode:
          if (pattern31 (x2, 
E_V4HImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1342; /* addv4hi3 */

        case E_V8HImode:
          if (pattern31 (x2, 
E_V8HImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1345; /* addv8hi3 */

        case E_V2SImode:
          if (pattern31 (x2, 
E_V2SImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1346; /* addv2si3 */

        case E_V4SImode:
          if (pattern31 (x2, 
E_V4SImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1349; /* addv4si3 */

        case E_V2DImode:
          if (pattern31 (x2, 
E_V2DImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1350; /* addv2di3 */

        case E_V4HFmode:
          if (pattern31 (x2, 
E_V4HFmode) != 0
              || !(
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2345; /* addv4hf3 */

        case E_V8HFmode:
          if (pattern31 (x2, 
E_V8HFmode) != 0
              || !(
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2348; /* addv8hf3 */

        case E_V2SFmode:
          if (pattern31 (x2, 
E_V2SFmode) != 0
              || !
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2349; /* addv2sf3 */

        case E_V4SFmode:
          if (pattern31 (x2, 
E_V4SFmode) != 0
              || !
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2352; /* addv4sf3 */

        case E_V2DFmode:
          if (pattern31 (x2, 
E_V2DFmode) != 0
              || !
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2353; /* addv2df3 */

        case E_VNx16QImode:
          if (pattern725 (x2, 
E_VNx16QImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7955; /* addvnx16qi3 */

        case E_VNx8QImode:
          if (pattern725 (x2, 
E_VNx8QImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7956; /* addvnx8qi3 */

        case E_VNx4QImode:
          if (pattern725 (x2, 
E_VNx4QImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7957; /* addvnx4qi3 */

        case E_VNx2QImode:
          if (pattern725 (x2, 
E_VNx2QImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7958; /* addvnx2qi3 */

        case E_VNx8HImode:
          if (pattern725 (x2, 
E_VNx8HImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7959; /* addvnx8hi3 */

        case E_VNx4HImode:
          if (pattern725 (x2, 
E_VNx4HImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7960; /* addvnx4hi3 */

        case E_VNx2HImode:
          if (pattern725 (x2, 
E_VNx2HImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7961; /* addvnx2hi3 */

        case E_VNx4SImode:
          if (pattern725 (x2, 
E_VNx4SImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7962; /* addvnx4si3 */

        case E_VNx2SImode:
          if (pattern725 (x2, 
E_VNx2SImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7963; /* addvnx2si3 */

        case E_VNx2DImode:
          if (pattern725 (x2, 
E_VNx2DImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7964; /* addvnx2di3 */

        case E_VNx8BFmode:
          if (pattern31 (x2, 
E_VNx8BFmode) != 0
              || !(
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8470; /* *post_ra_faddvnx8bf3 */

        case E_VNx8HFmode:
          if (pattern31 (x2, 
E_VNx8HFmode) != 0
              || !
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8473; /* *post_ra_faddvnx8hf3 */

        case E_VNx4SFmode:
          if (pattern31 (x2, 
E_VNx4SFmode) != 0
              || !
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8476; /* *post_ra_faddvnx4sf3 */

        case E_VNx2DFmode:
          if (pattern31 (x2, 
E_VNx2DFmode) != 0
              || !
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8479; /* *post_ra_faddvnx2df3 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern482 (x2, 
E_V4SFmode) != 0)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V8BFmode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_V8BFmode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 583:
              if (!
#line 9728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                return -1;
              return 5256; /* aarch64_bfmmlaqv4sf */

            case 579:
              if (!
#line 9740 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                return -1;
              return 5257; /* aarch64_bfmlalbv4sf */

            case 580:
              if (!
#line 9740 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                return -1;
              return 5258; /* aarch64_bfmlaltv4sf */

            default:
              return -1;
            }

        case 3:
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V8BFmode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          x7 = XVECEXP (x4, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 579:
              switch (GET_MODE (operands[3]))
                {
                case E_V4BFmode:
                  if (!register_operand (operands[3], E_V4BFmode)
                      || !
#line 9752 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5259; /* aarch64_bfmlalb_lanev4sf */

                case E_V8BFmode:
                  if (!register_operand (operands[3], E_V8BFmode)
                      || !
#line 9752 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5261; /* aarch64_bfmlalb_lane_qv4sf */

                default:
                  return -1;
                }

            case 580:
              switch (GET_MODE (operands[3]))
                {
                case E_V4BFmode:
                  if (!register_operand (operands[3], E_V4BFmode)
                      || !
#line 9752 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5260; /* aarch64_bfmlalt_lanev4sf */

                case E_V8BFmode:
                  if (!register_operand (operands[3], E_V8BFmode)
                      || !
#line 9752 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5262; /* aarch64_bfmlalt_lane_qv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern35 (x2))
        {
        case 0:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11415; /* aarch64_sve_single_addvnx32qi */

        case 1:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11420; /* aarch64_sve_single_addvnx16hi */

        case 2:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11425; /* aarch64_sve_single_addvnx8si */

        case 3:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11430; /* aarch64_sve_single_addvnx4di */

        case 4:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11435; /* aarch64_sve_single_addvnx64qi */

        case 5:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11440; /* aarch64_sve_single_addvnx32hi */

        case 6:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11445; /* aarch64_sve_single_addvnx16si */

        case 7:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11450; /* aarch64_sve_single_addvnx8di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_464 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern629 (x2, 
E_SImode) != 0)
            return -1;
          return 382; /* *msubsi */

        case E_DImode:
          if (pattern629 (x2, 
E_DImode) != 0)
            return -1;
          return 383; /* *msubdi */

        case E_V8QImode:
          if (pattern630 (x2, 
E_V8QImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2021; /* aarch64_mlsv8qi */

        case E_V16QImode:
          if (pattern630 (x2, 
E_V16QImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2024; /* aarch64_mlsv16qi */

        case E_V4HImode:
          if (pattern630 (x2, 
E_V4HImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2025; /* aarch64_mlsv4hi */

        case E_V8HImode:
          if (pattern630 (x2, 
E_V8HImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2028; /* aarch64_mlsv8hi */

        case E_V2SImode:
          if (pattern630 (x2, 
E_V2SImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2029; /* aarch64_mlsv2si */

        case E_V4SImode:
          if (pattern630 (x2, 
E_V4SImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2032; /* aarch64_mlsv4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern733 (x2))
                {
                case 0:
                  return 392; /* msubsidi4 */

                case 1:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2261; /* aarch64_smlslv8qi */

                case 2:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2263; /* aarch64_smlslv4hi */

                case 3:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2265; /* aarch64_smlslv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern735 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2216 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2267; /* aarch64_smlsl_nv4hi */

                case 1:
                  if (!
#line 2216 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2269; /* aarch64_smlsl_nv2si */

                case 2:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2329; /* aarch64_vec_smlsl_lane_v4hi */

                case 3:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2331; /* aarch64_vec_smlsl_laneq_v4hi */

                case 4:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2333; /* aarch64_vec_smlsl_lane_v2si */

                case 5:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2335; /* aarch64_vec_smlsl_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern940 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2235; /* *aarch64_smlsl_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2241; /* aarch64_smlsl_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2237; /* *aarch64_smlsl_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2243; /* aarch64_smlsl_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2239; /* *aarch64_smlsl_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2245; /* aarch64_smlsl_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern942 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2144 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2247; /* aarch64_smlsl_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2144 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2249; /* aarch64_smlsl_hi_nv4si_insn */

                case 2:
                  if (!
#line 2545 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2337; /* aarch64_smlsl_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2583 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2341; /* aarch64_smlsl_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2545 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2339; /* aarch64_smlsl_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2583 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2343; /* aarch64_smlsl_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern733 (x2))
                {
                case 0:
                  return 393; /* umsubsidi4 */

                case 1:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2262; /* aarch64_umlslv8qi */

                case 2:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2264; /* aarch64_umlslv4hi */

                case 3:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2266; /* aarch64_umlslv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern735 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2216 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2268; /* aarch64_umlsl_nv4hi */

                case 1:
                  if (!
#line 2216 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2270; /* aarch64_umlsl_nv2si */

                case 2:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2330; /* aarch64_vec_umlsl_lane_v4hi */

                case 3:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2332; /* aarch64_vec_umlsl_laneq_v4hi */

                case 4:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2334; /* aarch64_vec_umlsl_lane_v2si */

                case 5:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2336; /* aarch64_vec_umlsl_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern940 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2236; /* *aarch64_umlsl_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2242; /* aarch64_umlsl_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2238; /* *aarch64_umlsl_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2244; /* aarch64_umlsl_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2240; /* *aarch64_umlsl_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2246; /* aarch64_umlsl_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern942 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2144 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2248; /* aarch64_umlsl_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2144 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2250; /* aarch64_umlsl_hi_nv4si_insn */

                case 2:
                  if (!
#line 2545 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2338; /* aarch64_umlsl_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2583 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2342; /* aarch64_umlsl_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2545 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2340; /* aarch64_umlsl_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2583 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2344; /* aarch64_umlsl_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          x9 = XEXP (x5, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 1)
            return -1;
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          x10 = XVECEXP (x9, 0, 0);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern1159 (x2, 
E_V4HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2033; /* *aarch64_mls_eltv4hi */

                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2041; /* *aarch64_mls_elt_to_128v4hi */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern1159 (x2, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2036; /* *aarch64_mls_eltv8hi */

                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2044; /* *aarch64_mls_elt_to_64v8hi */

                default:
                  return -1;
                }

            case E_V2SImode:
              if (pattern1159 (x2, 
E_V2SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2037; /* *aarch64_mls_eltv2si */

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2045; /* *aarch64_mls_elt_to_128v2si */

                default:
                  return -1;
                }

            case E_V4SImode:
              if (pattern1159 (x2, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2040; /* *aarch64_mls_eltv4si */

                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2048; /* *aarch64_mls_elt_to_64v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x5;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern943 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2049; /* aarch64_mls_nv4hi */

            case E_V8HImode:
              if (pattern943 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2052; /* aarch64_mls_nv8hi */

            case E_V2SImode:
              if (pattern943 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2053; /* aarch64_mls_nv2si */

            case E_V4SImode:
              if (pattern943 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2056; /* aarch64_mls_nv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 167)
        return -1;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x11 = XVECEXP (x4, 0, 0);
      operands[3] = x11;
      x12 = XVECEXP (x4, 0, 1);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern1122 (x2, 
E_VNx8HImode) != 0
              || !
#line 1509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11843; /* aarch64_sve_sub_mul_lane_vnx8hi */

        case E_VNx4SImode:
          if (pattern1122 (x2, 
E_VNx4SImode) != 0
              || !
#line 1509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11844; /* aarch64_sve_sub_mul_lane_vnx4si */

        case E_VNx2DImode:
          if (pattern1122 (x2, 
E_VNx2DImode) != 0
              || !
#line 1509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11845; /* aarch64_sve_sub_mul_lane_vnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_480 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (XVECLEN (x4, 0) == 1)
    {
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern807 (x2, 
E_V8QImode, 
E_QImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1244; /* aarch64_dup_lanev8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1258; /* aarch64_dup_lane_to_128v8qi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V16QImode:
          if (pattern807 (x2, 
E_V16QImode, 
E_QImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1245; /* aarch64_dup_lanev16qi */
                  break;

                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1259; /* aarch64_dup_lane_to_64v16qi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4HImode:
          if (pattern807 (x2, 
E_V4HImode, 
E_HImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1246; /* aarch64_dup_lanev4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1260; /* aarch64_dup_lane_to_128v4hi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V8HImode:
          if (pattern807 (x2, 
E_V8HImode, 
E_HImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1247; /* aarch64_dup_lanev8hi */
                  break;

                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1261; /* aarch64_dup_lane_to_64v8hi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2SImode:
          if (pattern807 (x2, 
E_V2SImode, 
E_SImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1248; /* aarch64_dup_lanev2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1262; /* aarch64_dup_lane_to_128v2si */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SImode:
          if (pattern807 (x2, 
E_V4SImode, 
E_SImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1249; /* aarch64_dup_lanev4si */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1263; /* aarch64_dup_lane_to_64v4si */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2DImode:
          if (pattern808 (x2, 
E_V2DImode, 
E_DImode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1250; /* aarch64_dup_lanev2di */
          break;

        case E_V4HFmode:
          if (pattern807 (x2, 
E_V4HFmode, 
E_HFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1251; /* aarch64_dup_lanev4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1264; /* aarch64_dup_lane_to_128v4hf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V8HFmode:
          if (pattern807 (x2, 
E_V8HFmode, 
E_HFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1252; /* aarch64_dup_lanev8hf */
                  break;

                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1265; /* aarch64_dup_lane_to_64v8hf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4BFmode:
          if (pattern808 (x2, 
E_V4BFmode, 
E_BFmode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1253; /* aarch64_dup_lanev4bf */
          break;

        case E_V8BFmode:
          if (pattern808 (x2, 
E_V8BFmode, 
E_BFmode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1254; /* aarch64_dup_lanev8bf */
          break;

        case E_V2SFmode:
          if (pattern807 (x2, 
E_V2SFmode, 
E_SFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1255; /* aarch64_dup_lanev2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1266; /* aarch64_dup_lane_to_128v2sf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SFmode:
          if (pattern807 (x2, 
E_V4SFmode, 
E_SFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1256; /* aarch64_dup_lanev4sf */
                  break;

                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1267; /* aarch64_dup_lane_to_64v4sf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2DFmode:
          if (pattern808 (x2, 
E_V2DFmode, 
E_DFmode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1257; /* aarch64_dup_lanev2df */
          break;

        case E_VNx16QImode:
          if (pattern809 (x2, 
E_VNx16QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 8 / 8, 0, 63)))
            return 10404; /* aarch64_sve_dup_lanevnx16qi */
          break;

        case E_VNx8QImode:
          if (pattern809 (x2, 
E_VNx8QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10405; /* aarch64_sve_dup_lanevnx8qi */
          break;

        case E_VNx4QImode:
          if (pattern809 (x2, 
E_VNx4QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10406; /* aarch64_sve_dup_lanevnx4qi */
          break;

        case E_VNx2QImode:
          if (pattern809 (x2, 
E_VNx2QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10407; /* aarch64_sve_dup_lanevnx2qi */
          break;

        case E_VNx8HImode:
          if (pattern809 (x2, 
E_VNx8HImode, 
E_HImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10408; /* aarch64_sve_dup_lanevnx8hi */
          break;

        case E_VNx4HImode:
          if (pattern809 (x2, 
E_VNx4HImode, 
E_HImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10409; /* aarch64_sve_dup_lanevnx4hi */
          break;

        case E_VNx2HImode:
          if (pattern809 (x2, 
E_VNx2HImode, 
E_HImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10410; /* aarch64_sve_dup_lanevnx2hi */
          break;

        case E_VNx4SImode:
          if (pattern809 (x2, 
E_VNx4SImode, 
E_SImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10411; /* aarch64_sve_dup_lanevnx4si */
          break;

        case E_VNx2SImode:
          if (pattern809 (x2, 
E_VNx2SImode, 
E_SImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10412; /* aarch64_sve_dup_lanevnx2si */
          break;

        case E_VNx2DImode:
          if (pattern809 (x2, 
E_VNx2DImode, 
E_DImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10413; /* aarch64_sve_dup_lanevnx2di */
          break;

        case E_VNx8HFmode:
          if (pattern809 (x2, 
E_VNx8HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10414; /* aarch64_sve_dup_lanevnx8hf */
          break;

        case E_VNx4HFmode:
          if (pattern809 (x2, 
E_VNx4HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10415; /* aarch64_sve_dup_lanevnx4hf */
          break;

        case E_VNx2HFmode:
          if (pattern809 (x2, 
E_VNx2HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10416; /* aarch64_sve_dup_lanevnx2hf */
          break;

        case E_VNx8BFmode:
          if (pattern809 (x2, 
E_VNx8BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10417; /* aarch64_sve_dup_lanevnx8bf */
          break;

        case E_VNx4BFmode:
          if (pattern809 (x2, 
E_VNx4BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10418; /* aarch64_sve_dup_lanevnx4bf */
          break;

        case E_VNx2BFmode:
          if (pattern809 (x2, 
E_VNx2BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10419; /* aarch64_sve_dup_lanevnx2bf */
          break;

        case E_VNx4SFmode:
          if (pattern809 (x2, 
E_VNx4SFmode, 
E_SFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10420; /* aarch64_sve_dup_lanevnx4sf */
          break;

        case E_VNx2SFmode:
          if (pattern809 (x2, 
E_VNx2SFmode, 
E_SFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10421; /* aarch64_sve_dup_lanevnx2sf */
          break;

        case E_VNx2DFmode:
          if (pattern809 (x2, 
E_VNx2DFmode, 
E_DFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10422; /* aarch64_sve_dup_lanevnx2df */
          break;

        default:
          break;
        }
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x2) != E_VNx16QImode
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V16QImode) - 1)))
            return -1;
          return 6421; /* aarch64_vec_duplicate_vqvnx16qi_be */

        case E_VNx16QImode:
          if (!register_operand (operands[1], E_VNx16QImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (QImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (QImode), 0, 63)))
            return -1;
          return 10423; /* aarch64_sve_dupq_lanevnx16qi */

        default:
          return -1;
        }

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HImode) - 1)))
            return -1;
          return 6422; /* aarch64_vec_duplicate_vqvnx8hi_be */

        case E_VNx8HImode:
          if (!register_operand (operands[1], E_VNx8HImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (HImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (HImode), 0, 63)))
            return -1;
          return 10424; /* aarch64_sve_dupq_lanevnx8hi */

        default:
          return -1;
        }

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SImode) - 1)))
            return -1;
          return 6423; /* aarch64_vec_duplicate_vqvnx4si_be */

        case E_VNx4SImode:
          if (!register_operand (operands[1], E_VNx4SImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (SImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (SImode), 0, 63)))
            return -1;
          return 10425; /* aarch64_sve_dupq_lanevnx4si */

        default:
          return -1;
        }

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DImode) - 1)))
            return -1;
          return 6424; /* aarch64_vec_duplicate_vqvnx2di_be */

        case E_VNx2DImode:
          if (!register_operand (operands[1], E_VNx2DImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (DImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (DImode), 0, 63)))
            return -1;
          return 10426; /* aarch64_sve_dupq_lanevnx2di */

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x2) != E_VNx8BFmode
          || GET_MODE (x3) != E_V8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8BFmode) - 1)))
            return -1;
          return 6425; /* aarch64_vec_duplicate_vqvnx8bf_be */

        case E_VNx8BFmode:
          if (!register_operand (operands[1], E_VNx8BFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (BFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (BFmode), 0, 63)))
            return -1;
          return 10427; /* aarch64_sve_dupq_lanevnx8bf */

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x2) != E_VNx8HFmode
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HFmode) - 1)))
            return -1;
          return 6426; /* aarch64_vec_duplicate_vqvnx8hf_be */

        case E_VNx8HFmode:
          if (!register_operand (operands[1], E_VNx8HFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (HFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (HFmode), 0, 63)))
            return -1;
          return 10428; /* aarch64_sve_dupq_lanevnx8hf */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x2) != E_VNx4SFmode
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SFmode) - 1)))
            return -1;
          return 6427; /* aarch64_vec_duplicate_vqvnx4sf_be */

        case E_VNx4SFmode:
          if (!register_operand (operands[1], E_VNx4SFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (SFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (SFmode), 0, 63)))
            return -1;
          return 10429; /* aarch64_sve_dupq_lanevnx4sf */

        default:
          return -1;
        }

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x2) != E_VNx2DFmode
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DFmode) - 1)))
            return -1;
          return 6428; /* aarch64_vec_duplicate_vqvnx2df_be */

        case E_VNx2DFmode:
          if (!register_operand (operands[1], E_VNx2DFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (DFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (DFmode), 0, 63)))
            return -1;
          return 10430; /* aarch64_sve_dupq_lanevnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_491 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[0]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern824 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V16QImode, operands[1], operands[2])))
            return 2935; /* load_pair_lanesv8qi */
          break;

        case E_V8HImode:
          if (pattern824 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8HImode, operands[1], operands[2])))
            return 2936; /* load_pair_lanesv4hi */
          break;

        case E_V8BFmode:
          if (pattern824 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8BFmode, operands[1], operands[2])))
            return 2937; /* load_pair_lanesv4bf */
          break;

        case E_V8HFmode:
          if (pattern824 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8HFmode, operands[1], operands[2])))
            return 2938; /* load_pair_lanesv4hf */
          break;

        case E_V4SImode:
          if (pattern824 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V4SImode, operands[1], operands[2])))
            return 2939; /* load_pair_lanesv2si */
          break;

        case E_V4SFmode:
          if (pattern824 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V4SFmode, operands[1], operands[2])))
            return 2940; /* load_pair_lanesv2sf */
          break;

        case E_V2SImode:
          if (pattern824 (x2, 
E_SImode, 
E_V2SImode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2SImode, operands[1], operands[2])))
            return 2941; /* load_pair_lanessi */
          break;

        case E_V2SFmode:
          if (pattern824 (x2, 
E_SFmode, 
E_V2SFmode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2SFmode, operands[1], operands[2])))
            return 2942; /* load_pair_lanessf */
          break;

        case E_V2DImode:
          if (pattern824 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2DImode, operands[1], operands[2])))
            return 2943; /* load_pair_lanesdi */
          break;

        case E_V2DFmode:
          if (pattern824 (x2, 
E_DFmode, 
E_V2DFmode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2DFmode, operands[1], operands[2])))
            return 2944; /* load_pair_lanesdf */
          break;

        case E_VNx16QImode:
          if (pattern825 (x2, 
E_VNx8QImode, 
E_VNx16QImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10750; /* aarch64_pack_partialvnx16qi */
          break;

        case E_VNx8QImode:
          if (pattern825 (x2, 
E_VNx4QImode, 
E_VNx8QImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10751; /* aarch64_pack_partialvnx8qi */
          break;

        case E_VNx8HImode:
          if (pattern825 (x2, 
E_VNx4HImode, 
E_VNx8HImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10752; /* aarch64_pack_partialvnx8hi */
          break;

        case E_VNx8HFmode:
          if (pattern825 (x2, 
E_VNx4HFmode, 
E_VNx8HFmode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10753; /* aarch64_pack_partialvnx8hf */
          break;

        case E_VNx8BFmode:
          if (pattern825 (x2, 
E_VNx4BFmode, 
E_VNx8BFmode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10754; /* aarch64_pack_partialvnx8bf */
          break;

        case E_VNx4QImode:
          if (pattern825 (x2, 
E_VNx2QImode, 
E_VNx4QImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10755; /* aarch64_pack_partialvnx4qi */
          break;

        case E_VNx4HImode:
          if (pattern825 (x2, 
E_VNx2HImode, 
E_VNx4HImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10756; /* aarch64_pack_partialvnx4hi */
          break;

        case E_VNx4HFmode:
          if (pattern825 (x2, 
E_VNx2HFmode, 
E_VNx4HFmode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10757; /* aarch64_pack_partialvnx4hf */
          break;

        case E_VNx4BFmode:
          if (pattern825 (x2, 
E_VNx2BFmode, 
E_VNx4BFmode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10758; /* aarch64_pack_partialvnx4bf */
          break;

        case E_VNx4SImode:
          if (pattern825 (x2, 
E_VNx2SImode, 
E_VNx4SImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10759; /* aarch64_pack_partialvnx4si */
          break;

        case E_VNx4SFmode:
          if (pattern825 (x2, 
E_VNx2SFmode, 
E_VNx4SFmode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10760; /* aarch64_pack_partialvnx4sf */
          break;

        default:
          break;
        }
      break;

    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern826 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2945; /* store_pair_lanesv8qi */
          break;

        case E_V8HImode:
          if (pattern826 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2946; /* store_pair_lanesv4hi */
          break;

        case E_V8BFmode:
          if (pattern826 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2947; /* store_pair_lanesv4bf */
          break;

        case E_V8HFmode:
          if (pattern826 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2948; /* store_pair_lanesv4hf */
          break;

        case E_V4SImode:
          if (pattern826 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2949; /* store_pair_lanesv2si */
          break;

        case E_V4SFmode:
          if (pattern826 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2950; /* store_pair_lanesv2sf */
          break;

        case E_V2SImode:
          if (pattern826 (x2, 
E_SImode, 
E_V2SImode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2951; /* store_pair_lanessi */
          break;

        case E_V2SFmode:
          if (pattern826 (x2, 
E_SFmode, 
E_V2SFmode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2952; /* store_pair_lanessf */
          break;

        case E_V2DImode:
          if (pattern826 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2953; /* store_pair_lanesdi */
          break;

        case E_V2DFmode:
          if (pattern826 (x2, 
E_DFmode, 
E_V2DFmode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2954; /* store_pair_lanesdf */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V8QImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V8QImode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[2], V8QImode))))
            return 2955; /* *aarch64_combine_internalv8qi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V8QImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V8QImode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[2], V8QImode))))
        return -1;
      return 2965; /* *aarch64_combine_internal_bev8qi */

    case E_V8HImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4HImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4HImode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[2], V4HImode))))
            return 2956; /* *aarch64_combine_internalv4hi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4HImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HImode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[2], V4HImode))))
        return -1;
      return 2966; /* *aarch64_combine_internal_bev4hi */

    case E_V8BFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4BFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4BFmode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[2], V4BFmode))))
            return 2957; /* *aarch64_combine_internalv4bf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4BFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4BFmode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[2], V4BFmode))))
        return -1;
      return 2967; /* *aarch64_combine_internal_bev4bf */

    case E_V8HFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4HFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4HFmode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[2], V4HFmode))))
            return 2958; /* *aarch64_combine_internalv4hf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4HFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HFmode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[2], V4HFmode))))
        return -1;
      return 2968; /* *aarch64_combine_internal_bev4hf */

    case E_V4SImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V2SImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V2SImode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[2], V2SImode))))
            return 2959; /* *aarch64_combine_internalv2si */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V2SImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SImode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[2], V2SImode))))
        return -1;
      return 2969; /* *aarch64_combine_internal_bev2si */

    case E_V4SFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V2SFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V2SFmode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[2], V2SFmode))))
            return 2960; /* *aarch64_combine_internalv2sf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V2SFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SFmode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[2], V2SFmode))))
        return -1;
      return 2970; /* *aarch64_combine_internal_bev2sf */

    case E_V2SImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_SImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_SImode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[2], SImode))))
            return 2961; /* *aarch64_combine_internalsi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_SImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[2], SImode))))
        return -1;
      return 2971; /* *aarch64_combine_internal_besi */

    case E_V2SFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_SFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_SFmode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[2], SFmode))))
            return 2962; /* *aarch64_combine_internalsf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_SFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[2], SFmode))))
        return -1;
      return 2972; /* *aarch64_combine_internal_besf */

    case E_V2DImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_DImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_DImode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[2], DImode))))
            return 2963; /* *aarch64_combine_internaldi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_DImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[2], DImode))))
        return -1;
      return 2973; /* *aarch64_combine_internal_bedi */

    case E_V2DFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_DFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_DFmode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[2], DFmode))))
            return 2964; /* *aarch64_combine_internaldf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_DFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[2], DFmode))))
        return -1;
      return 2974; /* *aarch64_combine_internal_bedf */

    default:
      return -1;
    }
}

 int
recog_500 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          operands[1] = x4;
          switch (pattern315 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1352; /* subv8qi3_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1356; /* subv4hi3_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1360; /* subv2si3_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2644 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2355; /* subv4hf3_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2644 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2359; /* subv2sf3_vec_concatz_le */

            default:
              return -1;
            }

        case MULT:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[2] = x6;
              operands[1] = x4;
              x7 = XEXP (x5, 1);
              operands[3] = x7;
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1016 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2022; /* aarch64_mlsv8qi_vec_concatz_le */

                case E_V8HImode:
                  if (pattern1016 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2026; /* aarch64_mlsv4hi_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1016 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2030; /* aarch64_mlsv2si_vec_concatz_le */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x9 = XEXP (x6, 0);
              switch (GET_CODE (x9))
                {
                case VEC_SELECT:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != PARALLEL
                      || XVECLEN (x10, 0) != 1)
                    return -1;
                  operands[4] = x4;
                  x11 = XEXP (x9, 0);
                  operands[1] = x11;
                  x12 = XVECEXP (x10, 0, 0);
                  operands[2] = x12;
                  if (!immediate_operand (operands[2], E_SImode))
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  x8 = XEXP (x2, 1);
                  operands[5] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1224 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V4HImode:
                          if (!register_operand (operands[1], E_V4HImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2034; /* *aarch64_mls_eltv4hi_vec_concatz_le */

                        case E_V8HImode:
                          if (!register_operand (operands[1], E_V8HImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2042; /* *aarch64_mls_elt_to_128v4hi_vec_concatz_le */

                        default:
                          return -1;
                        }

                    case E_V4SImode:
                      if (pattern1224 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V2SImode:
                          if (!register_operand (operands[1], E_V2SImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2038; /* *aarch64_mls_eltv2si_vec_concatz_le */

                        case E_V4SImode:
                          if (!register_operand (operands[1], E_V4SImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2046; /* *aarch64_mls_elt_to_128v2si_vec_concatz_le */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[3] = x9;
                  operands[1] = x4;
                  x7 = XEXP (x5, 1);
                  operands[2] = x7;
                  x8 = XEXP (x2, 1);
                  operands[4] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1072 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2050; /* aarch64_mls_nv4hi_vec_concatz_le */

                    case E_V4SImode:
                      if (pattern1072 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2054; /* aarch64_mls_nv2si_vec_concatz_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern414 (x2, 
SMIN))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1627; /* aarch64_sabdv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1635; /* aarch64_sabdv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1643; /* aarch64_sabdv2si_vec_concatz_le */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern414 (x2, 
UMIN))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1630; /* aarch64_uabdv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1638; /* aarch64_uabdv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1646; /* aarch64_uabdv2si_vec_concatz_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_503 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_459 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          switch (pattern49 (x3))
            {
            case 0:
              return 205; /* *add_lsl_si */

            case 1:
              return 208; /* *add_lsl_di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern605 (x3))
            {
            case 0:
              return 234; /* *add_extendqi_shft_si */

            case 1:
              return 238; /* *add_extendhi_shft_si */

            case 2:
              return 242; /* *add_extendsi_shft_si */

            case 3:
              return 236; /* *add_extendqi_shft_di */

            case 4:
              return 240; /* *add_extendhi_shft_di */

            case 5:
              return 244; /* *add_extendsi_shft_di */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern605 (x3))
            {
            case 0:
              return 235; /* *add_zero_extendqi_shft_si */

            case 1:
              return 239; /* *add_zero_extendhi_shft_si */

            case 2:
              return 243; /* *add_zero_extendsi_shft_si */

            case 3:
              return 237; /* *add_zero_extendqi_shft_di */

            case 4:
              return 241; /* *add_zero_extendhi_shft_di */

            case 5:
              return 245; /* *add_zero_extendsi_shft_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern284 (x3))
        {
        case 0:
          return 206; /* *add_asr_si */

        case 1:
          return 209; /* *add_asr_di */

        case 2:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1878; /* aarch64_ssra_nv8qi_insn */

        case 3:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1880; /* aarch64_ssra_nv16qi_insn */

        case 4:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1882; /* aarch64_ssra_nv4hi_insn */

        case 5:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1884; /* aarch64_ssra_nv8hi_insn */

        case 6:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1886; /* aarch64_ssra_nv2si_insn */

        case 7:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1888; /* aarch64_ssra_nv4si_insn */

        case 8:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1890; /* aarch64_ssra_nv2di_insn */

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern284 (x3))
            {
            case 0:
              return 207; /* *add_lsr_si */

            case 1:
              return 210; /* *add_lsr_di */

            case 2:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1879; /* aarch64_usra_nv8qi_insn */

            case 3:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1881; /* aarch64_usra_nv16qi_insn */

            case 4:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1883; /* aarch64_usra_nv4hi_insn */

            case 5:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1885; /* aarch64_usra_nv8hi_insn */

            case 6:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1887; /* aarch64_usra_nv2si_insn */

            case 7:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1889; /* aarch64_usra_nv4si_insn */

            case 8:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1891; /* aarch64_usra_nv2di_insn */

            default:
              return -1;
            }

        case PLUS:
          switch (pattern374 (x3))
            {
            case 0:
              if (!
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3199; /* *bitmask_shift_plusv8hi */

            case 1:
              if (!
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3200; /* *bitmask_shift_plusv4si */

            case 2:
              if (!
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3201; /* *bitmask_shift_plusv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_462 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_461 (x1, insn, pnum_clobbers);

    case PLUS:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case GEU:
        case LTU:
          operands[3] = x7;
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern794 (x3, 
E_SImode) != 0)
                return -1;
              return 250; /* *addsi3_carryin */

            case E_DImode:
              if (pattern794 (x3, 
E_DImode) != 0)
                return -1;
              return 251; /* *adddi3_carryin */

            default:
              return -1;
            }

        case VEC_SELECT:
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != VEC_SELECT)
            return -1;
          x8 = XEXP (x7, 1);
          operands[3] = x8;
          x9 = XEXP (x5, 1);
          operands[4] = x9;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          x10 = XEXP (x7, 0);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              switch (pattern870 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1686; /* *aarch64_sadalpv8qi_insn */

                case 1:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1692; /* *aarch64_sadalpv16qi_insn */

                case 2:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1694; /* *aarch64_sadalpv4hi_insn */

                case 3:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1700; /* *aarch64_sadalpv8hi_insn */

                case 4:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1702; /* *aarch64_sadalpv4si_insn */

                case 5:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1704; /* *aarch64_sadalpv2si_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern870 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1689; /* *aarch64_uadalpv8qi_insn */

                case 1:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1693; /* *aarch64_uadalpv16qi_insn */

                case 2:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1697; /* *aarch64_uadalpv4hi_insn */

                case 3:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1701; /* *aarch64_uadalpv8hi_insn */

                case 4:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1703; /* *aarch64_uadalpv4si_insn */

                case 5:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1707; /* *aarch64_uadalpv2si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x4, 1);
      operands[3] = x5;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case ASHIFT:
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          x8 = XEXP (x7, 1);
          operands[2] = x8;
          if (!aarch64_imm3 (operands[2], E_VOIDmode)
              || !const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern987 (x3, 
E_SImode) != 0
                  || !
#line 3214 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]), INTVAL (operands[3])) != 0))
                return -1;
              return 261; /* *add_uxtsi_shift2 */

            case E_DImode:
              if (pattern987 (x3, 
E_DImode) != 0
                  || !
#line 3214 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]), INTVAL (operands[3])) != 0))
                return -1;
              return 262; /* *add_uxtdi_shift2 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!register_operand (operands[2], E_VNx2DImode)
              || !register_operand (operands[0], E_VNx2DImode)
              || GET_MODE (x3) != E_VNx2DImode
              || GET_MODE (x4) != E_VNx2DImode
              || !aarch64_sve_uxtw_immediate (operands[3], E_VNx2DImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_VNx2DImode)
              || !
#line 4177 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 7979; /* *aarch64_adr_uxtw_and */

        default:
          return -1;
        }

    case MULT:
      return recog_458 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_463 (x1, insn, pnum_clobbers);

    case SMAX:
      switch (pattern286 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 493; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 497; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern286 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 494; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 498; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern286 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 495; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 499; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern286 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 496; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 500; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_460 (x1, insn, pnum_clobbers);

    case MINUS:
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case SMAX:
          switch (pattern497 (x3, 
SMIN))
            {
            case 0:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1710; /* aarch64_sabav8qi */

            case 1:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1716; /* aarch64_sabav16qi */

            case 2:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1718; /* aarch64_sabav4hi */

            case 3:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1724; /* aarch64_sabav8hi */

            case 4:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1726; /* aarch64_sabav2si */

            case 5:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1732; /* aarch64_sabav4si */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern497 (x3, 
UMIN))
            {
            case 0:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1713; /* aarch64_uabav8qi */

            case 1:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1717; /* aarch64_uabav16qi */

            case 2:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1721; /* aarch64_uabav4hi */

            case 3:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1725; /* aarch64_uabav8hi */

            case 4:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1729; /* aarch64_uabav2si */

            case 5:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1733; /* aarch64_uabav4si */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x7, 0) != 2
              || XINT (x7, 1) != 125)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 125)
            return -1;
          x11 = XVECEXP (x7, 0, 0);
          operands[4] = x11;
          x12 = XVECEXP (x5, 0, 0);
          operands[5] = x12;
          x13 = XVECEXP (x7, 0, 1);
          switch (GET_CODE (x13))
            {
            case SMAX:
              switch (pattern1120 (x3, 
SMIN))
                {
                case 0:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11993; /* *aarch64_sve2_sabavnx16qi */

                case 1:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11995; /* *aarch64_sve2_sabavnx8hi */

                case 2:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11997; /* *aarch64_sve2_sabavnx4si */

                case 3:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11999; /* *aarch64_sve2_sabavnx2di */

                default:
                  return -1;
                }

            case UMAX:
              switch (pattern1120 (x3, 
UMIN))
                {
                case 0:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11994; /* *aarch64_sve2_uabavnx16qi */

                case 1:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11996; /* *aarch64_sve2_uabavnx8hi */

                case 2:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11998; /* *aarch64_sve2_uabavnx4si */

                case 3:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12000; /* *aarch64_sve2_uabavnx2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case ASHIFTRT:
          switch (pattern498 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1899; /* aarch64_srsra_nv8qi_insn */

            case 1:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1901; /* aarch64_srsra_nv16qi_insn */

            case 2:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1903; /* aarch64_srsra_nv4hi_insn */

            case 3:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1905; /* aarch64_srsra_nv8hi_insn */

            case 4:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1907; /* aarch64_srsra_nv2si_insn */

            case 5:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1909; /* aarch64_srsra_nv4si_insn */

            case 6:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1911; /* aarch64_srsra_nv2di_insn */

            case 7:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1913; /* aarch64_srsra_ndi_insn */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern498 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1900; /* aarch64_ursra_nv8qi_insn */

            case 1:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1902; /* aarch64_ursra_nv16qi_insn */

            case 2:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1904; /* aarch64_ursra_nv4hi_insn */

            case 3:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1906; /* aarch64_ursra_nv8hi_insn */

            case 4:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1908; /* aarch64_ursra_nv2si_insn */

            case 5:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1910; /* aarch64_ursra_nv4si_insn */

            case 6:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1912; /* aarch64_ursra_nv2di_insn */

            case 7:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1914; /* aarch64_ursra_ndi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          switch (pattern500 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2779; /* *aarch64_saddlpv8qi_insn */

            case 1:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2785; /* *aarch64_saddlpv16qi_insn */

            case 2:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2787; /* *aarch64_saddlpv4hi_insn */

            case 3:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2793; /* *aarch64_saddlpv8hi_insn */

            case 4:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2795; /* *aarch64_saddlpv4si_insn */

            case 5:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2797; /* *aarch64_saddlpv2si_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern500 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2782; /* *aarch64_uaddlpv8qi_insn */

            case 1:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2786; /* *aarch64_uaddlpv16qi_insn */

            case 2:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2790; /* *aarch64_uaddlpv4hi_insn */

            case 3:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2794; /* *aarch64_uaddlpv8hi_insn */

            case 4:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2796; /* *aarch64_uaddlpv4si_insn */

            case 5:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2800; /* *aarch64_uaddlpv2si_insn */

            default:
              return -1;
            }

        case VEC_CONCAT:
          x14 = XEXP (x6, 0);
          if (GET_CODE (x14) != VEC_CONCAT)
            return -1;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          x8 = XEXP (x7, 1);
          operands[2] = x8;
          x5 = XEXP (x4, 1);
          operands[3] = x5;
          x15 = XEXP (x6, 1);
          operands[4] = x15;
          x16 = XEXP (x14, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          x17 = XEXP (x14, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern1121 (x3, 
E_V16QImode, 
E_V8QImode) != 0
                  || !
#line 7285 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4364; /* aarch64_addpv8qi_insn */

            case E_V4HImode:
              if (pattern1121 (x3, 
E_V8HImode, 
E_V4HImode) != 0
                  || !
#line 7285 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4367; /* aarch64_addpv4hi_insn */

            case E_V2SImode:
              if (pattern1121 (x3, 
E_V4SImode, 
E_V2SImode) != 0
                  || !
#line 7285 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4370; /* aarch64_addpv2si_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern446 (x3))
            {
            case 0:
              if (!
#line 7302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4373; /* *aarch64_addp_same_regv16qi */

            case 1:
              if (!
#line 7302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4374; /* *aarch64_addp_same_regv8hi */

            case 2:
              if (!
#line 7302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4375; /* *aarch64_addp_same_regv4si */

            case 3:
              if (!
#line 7302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4376; /* *aarch64_addp_same_regv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case TRUNCATE:
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern726 (x3, 
E_VNx16QImode, 
E_QImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6482; /* *vec_seriesvnx16qi_plus */
              break;

            case E_VNx8QImode:
              if (pattern726 (x3, 
E_VNx8QImode, 
E_QImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6483; /* *vec_seriesvnx8qi_plus */
              break;

            case E_VNx4QImode:
              if (pattern726 (x3, 
E_VNx4QImode, 
E_QImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6484; /* *vec_seriesvnx4qi_plus */
              break;

            case E_VNx2QImode:
              if (pattern726 (x3, 
E_VNx2QImode, 
E_QImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6485; /* *vec_seriesvnx2qi_plus */
              break;

            case E_VNx8HImode:
              if (pattern726 (x3, 
E_VNx8HImode, 
E_HImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6486; /* *vec_seriesvnx8hi_plus */
              break;

            case E_VNx4HImode:
              if (pattern726 (x3, 
E_VNx4HImode, 
E_HImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6487; /* *vec_seriesvnx4hi_plus */
              break;

            case E_VNx2HImode:
              if (pattern726 (x3, 
E_VNx2HImode, 
E_HImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6488; /* *vec_seriesvnx2hi_plus */
              break;

            case E_VNx4SImode:
              if (pattern726 (x3, 
E_VNx4SImode, 
E_SImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6489; /* *vec_seriesvnx4si_plus */
              break;

            case E_VNx2SImode:
              if (pattern726 (x3, 
E_VNx2SImode, 
E_SImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6490; /* *vec_seriesvnx2si_plus */
              break;

            case E_VNx2DImode:
              if (pattern726 (x3, 
E_VNx2DImode, 
E_DImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6491; /* *vec_seriesvnx2di_plus */
              break;

            default:
              break;
            }
          if (!subreg_lowpart_operator (x7, E_HImode)
              || pattern501 (x3, 
E_VNx8HImode) != 0)
            return -1;
          switch (pattern330 (x7))
            {
            case 0:
              if (!
#line 10502 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10969; /* *aarch64_sve_incvnx8hi_pat */

            case 1:
              if (!
#line 10903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11021; /* *aarch64_sve_incvnx8hi_cntp */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x7) != E_DImode
              || pattern501 (x3, 
E_VNx2DImode) != 0)
            return -1;
          x10 = XEXP (x7, 0);
          switch (pattern328 (x10))
            {
            case 0:
              if (!
#line 10446 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10963; /* aarch64_sve_incvnx2di_pat */

            case 1:
              if (!
#line 10823 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11015; /* *aarch64_sve_incvnx2di_cntp */

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern375 (x3, 
E_VNx4SImode) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          switch (pattern329 (x7))
            {
            case 0:
              if (!
#line 10467 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10966; /* aarch64_sve_incvnx4si_pat */

            case 1:
              if (!
#line 10862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11018; /* *aarch64_sve_incvnx4si_cntp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_519 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      return recog_465 (x1, insn, pnum_clobbers);

    case MINUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern798 (x3, 
E_SImode) != 0)
                return -1;
              return 330; /* *subsi3_carryin */

            case E_DImode:
              if (pattern798 (x3, 
E_DImode) != 0)
                return -1;
              return 331; /* *subdi3_carryin */

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[3] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern799 (x3, 
E_SImode) != 0)
                return -1;
              return 333; /* *subsi3_carryin_alt */

            case E_DImode:
              if (pattern799 (x3, 
E_DImode) != 0)
                return -1;
              return 334; /* *subdi3_carryin_alt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern636 (x3, 
E_SImode) != 0)
            return -1;
          return 354; /* *ngcsi */

        case E_DImode:
          if (pattern636 (x3, 
E_DImode) != 0)
            return -1;
          return 355; /* *ngcdi */

        default:
          return -1;
        }

    case UMAX:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[2]))
        {
        case CONST_POLY_INT:
          x7 = XEXP (x3, 1);
          if (!rtx_equal_p (x7, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern800 (x3, 
E_SImode) != 0
                  || !
#line 4948 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE))
                return -1;
              return 491; /* aarch64_uqdecsi */

            case E_DImode:
              if (pattern800 (x3, 
E_DImode) != 0
                  || !
#line 4948 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE))
                return -1;
              return 492; /* aarch64_uqdecdi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != UMIN)
            return -1;
          switch (pattern638 (x3))
            {
            case 0:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1629; /* aarch64_uabdv8qi */

            case 1:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1633; /* aarch64_uabdv16qi */

            case 2:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1637; /* aarch64_uabdv4hi */

            case 3:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1641; /* aarch64_uabdv8hi */

            case 4:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1645; /* aarch64_uabdv2si */

            case 5:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1649; /* aarch64_uabdv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT
          || XWINT (x6, 0) != 72057594037927935L)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != AND
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != CONST_INT
          || XWINT (x8, 0) != 72057594037927935L
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 8381 "../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
        return -1;
      return 1214; /* subp */

    case SMAX:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != SMIN)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (pattern638 (x3))
        {
        case 0:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1626; /* aarch64_sabdv8qi */

        case 1:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1632; /* aarch64_sabdv16qi */

        case 2:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1634; /* aarch64_sabdv4hi */

        case 3:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1640; /* aarch64_sabdv8hi */

        case 4:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1642; /* aarch64_sabdv2si */

        case 5:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1648; /* aarch64_sabdv4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern292 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2996; /* aarch64_ssublv16qi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3008; /* aarch64_ssublv16qi_lo_internal */

        case 1:
          if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3000; /* aarch64_ssublv8hi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3012; /* aarch64_ssublv8hi_lo_internal */

        case 2:
          if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3004; /* aarch64_ssublv4si_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3016; /* aarch64_ssublv4si_lo_internal */

        case 3:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3020; /* aarch64_ssublv8qi */

        case 4:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3024; /* aarch64_ssublv4hi */

        case 5:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3028; /* aarch64_ssublv2si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern292 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2998; /* aarch64_usublv16qi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3010; /* aarch64_usublv16qi_lo_internal */

        case 1:
          if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3002; /* aarch64_usublv8hi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3014; /* aarch64_usublv8hi_lo_internal */

        case 2:
          if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3006; /* aarch64_usublv4si_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3018; /* aarch64_usublv4si_lo_internal */

        case 3:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3022; /* aarch64_usublv8qi */

        case 4:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3026; /* aarch64_usublv4hi */

        case 5:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3030; /* aarch64_usublv2si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 125)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 2
          || XINT (x7, 1) != 125)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      operands[1] = x10;
      x11 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      switch (GET_CODE (x12))
        {
        case SMAX:
          switch (pattern991 (x3, 
SMIN))
            {
            case 0:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7989; /* aarch64_pred_sabdvnx16qi */

            case 1:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7991; /* aarch64_pred_sabdvnx8qi */

            case 2:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7993; /* aarch64_pred_sabdvnx4qi */

            case 3:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7995; /* aarch64_pred_sabdvnx2qi */

            case 4:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7997; /* aarch64_pred_sabdvnx8hi */

            case 5:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7999; /* aarch64_pred_sabdvnx4hi */

            case 6:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8001; /* aarch64_pred_sabdvnx2hi */

            case 7:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8003; /* aarch64_pred_sabdvnx4si */

            case 8:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8005; /* aarch64_pred_sabdvnx2si */

            case 9:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8007; /* aarch64_pred_sabdvnx2di */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern991 (x3, 
UMIN))
            {
            case 0:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7990; /* aarch64_pred_uabdvnx16qi */

            case 1:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7992; /* aarch64_pred_uabdvnx8qi */

            case 2:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7994; /* aarch64_pred_uabdvnx4qi */

            case 3:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7996; /* aarch64_pred_uabdvnx2qi */

            case 4:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7998; /* aarch64_pred_uabdvnx8hi */

            case 5:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8000; /* aarch64_pred_uabdvnx4hi */

            case 6:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8002; /* aarch64_pred_uabdvnx2hi */

            case 7:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8004; /* aarch64_pred_uabdvnx4si */

            case 8:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8006; /* aarch64_pred_uabdvnx2si */

            case 9:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8008; /* aarch64_pred_uabdvnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_526 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          x9 = XEXP (x8, 0);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern1018 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 6052 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3613; /* aarch64_sqdmullv4hi */

                case E_V2DImode:
                  if (pattern1018 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                      || !
#line 6052 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3614; /* aarch64_sqdmullv2si */

                case E_SImode:
                  if (pattern1018 (x2, 
E_HImode, 
E_SImode) != 0
                      || !
#line 6052 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3615; /* aarch64_sqdmullhi */

                case E_DImode:
                  if (pattern1018 (x2, 
E_SImode, 
E_DImode) != 0
                      || !
#line 6052 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3616; /* aarch64_sqdmullsi */

                default:
                  return -1;
                }

            case VEC_SELECT:
              x10 = XEXP (x9, 1);
              if (GET_CODE (x10) != PARALLEL
                  || XVECLEN (x10, 0) != 1)
                return -1;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              x12 = XVECEXP (x10, 0, 0);
              operands[3] = x12;
              if (!immediate_operand (operands[3], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern1199 (x2, 
E_HImode, 
E_SImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[2]))
                    {
                    case E_V4HImode:
                      if (!register_operand (operands[2], E_V4HImode)
                          || !
#line 6113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3621; /* aarch64_sqdmull_lanehi */

                    case E_V8HImode:
                      if (!register_operand (operands[2], E_V8HImode)
                          || !
#line 6133 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3623; /* aarch64_sqdmull_laneqhi */

                    default:
                      return -1;
                    }

                case E_DImode:
                  if (pattern1199 (x2, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[2]))
                    {
                    case E_V2SImode:
                      if (!register_operand (operands[2], E_V2SImode)
                          || !
#line 6113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3622; /* aarch64_sqdmull_lanesi */

                    case E_V4SImode:
                      if (!register_operand (operands[2], E_V4SImode)
                          || !
#line 6133 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3624; /* aarch64_sqdmull_laneqsi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x8, 0);
          switch (pattern829 (x9))
            {
            case 0:
              x11 = XEXP (x9, 0);
              x13 = XEXP (x11, 0);
              operands[2] = x13;
              x14 = XEXP (x11, 1);
              x15 = XVECEXP (x14, 0, 0);
              operands[3] = x15;
              if (!immediate_operand (operands[3], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern1228 (x2, 
E_V4HImode, 
E_V4SImode) != 0)
                    return -1;
                  switch (pattern1304 (x8))
                    {
                    case 0:
                      if (!
#line 6072 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3617; /* aarch64_sqdmull_lanev4hi */

                    case 1:
                      if (!
#line 6093 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3619; /* aarch64_sqdmull_laneqv4hi */

                    default:
                      return -1;
                    }

                case E_V2DImode:
                  if (pattern1228 (x2, 
E_V2SImode, 
E_V2DImode) != 0)
                    return -1;
                  switch (pattern1305 (x8))
                    {
                    case 0:
                      if (!
#line 6072 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3618; /* aarch64_sqdmull_lanev2si */

                    case 1:
                      if (!
#line 6093 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3620; /* aarch64_sqdmull_laneqv2si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 1:
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern1076 (x2, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V4HImode) != 0
                      || !
#line 6154 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3625; /* aarch64_sqdmull_nv4hi */

                case E_V2DImode:
                  if (pattern1076 (x2, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0
                      || !
#line 6154 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3626; /* aarch64_sqdmull_nv2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x16 = XEXP (x7, 0);
      operands[1] = x16;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != VEC_SELECT)
            return -1;
          x17 = XEXP (x7, 1);
          operands[3] = x17;
          x11 = XEXP (x9, 0);
          operands[2] = x11;
          x10 = XEXP (x9, 1);
          if (!rtx_equal_p (x10, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern1135 (x2, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0
                  || !
#line 6175 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3627; /* aarch64_sqdmull2v8hi_internal */

            case E_V2DImode:
              if (pattern1135 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0
                  || !
#line 6175 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3628; /* aarch64_sqdmull2v4si_internal */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x8, 0);
          switch (pattern829 (x9))
            {
            case 0:
              x17 = XEXP (x7, 1);
              operands[4] = x17;
              x11 = XEXP (x9, 0);
              x13 = XEXP (x11, 0);
              operands[2] = x13;
              x14 = XEXP (x11, 1);
              x15 = XVECEXP (x14, 0, 0);
              operands[3] = x15;
              if (!immediate_operand (operands[3], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern1252 (x2, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
                    return -1;
                  switch (pattern1304 (x8))
                    {
                    case 0:
                      if (!
#line 6209 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3629; /* aarch64_sqdmull2_lanev8hi_internal */

                    case 1:
                      if (!
#line 6232 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3631; /* aarch64_sqdmull2_laneqv8hi_internal */

                    default:
                      return -1;
                    }

                case E_V2DImode:
                  if (pattern1252 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
                    return -1;
                  switch (pattern1305 (x8))
                    {
                    case 0:
                      if (!
#line 6209 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3630; /* aarch64_sqdmull2_lanev4si_internal */

                    case 1:
                      if (!
#line 6232 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3632; /* aarch64_sqdmull2_laneqv4si_internal */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 1:
              x17 = XEXP (x7, 1);
              operands[3] = x17;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern1136 (x2, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0
                      || !
#line 6283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3633; /* aarch64_sqdmull2_nv8hi_internal */

                case E_V2DImode:
                  if (pattern1136 (x2, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0
                      || !
#line 6283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3634; /* aarch64_sqdmull2_nv4si_internal */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_544 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 2
      || XINT (x4, 1) != 6)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (pattern439 (x6, 
66, 
E_CCmode, 
CLOBBER) != 0)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != LABEL_REF
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x4, 0, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x10 = XVECEXP (x4, 0, 1);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  operands[3] = x12;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x13 = XEXP (x8, 0);
  operands[2] = x13;
  return 28; /* *casesi_dispatch */
}

 int
recog_547 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10131; /* while_wrsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10141; /* while_wrdivnx8bi_ptest */
}

 int
recog_551 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10051; /* *while_wrsivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10061; /* *while_wrdivnx8bi_cc */
}

 int
recog_555 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10130; /* while_rwsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10140; /* while_rwdivnx8bi_ptest */
}

 int
recog_563 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10129; /* while_ugesivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10139; /* while_ugedivnx8bi_ptest */
}

 int
recog_571 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10128; /* while_ugtsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10138; /* while_ugtdivnx8bi_ptest */
}

 int
recog_581 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3433 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10087; /* *while_gtsivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3433 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10097; /* *while_gtdivnx2bi_cc */
}

 int
recog_591 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3432 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10046; /* *while_gesivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3432 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10056; /* *while_gedivnx8bi_cc */
}

 int
recog_601 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern675 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9949; /* while_ugesivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9959; /* while_ugedivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9969; /* while_ugesivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9979; /* while_ugedivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9989; /* while_ugesivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9999; /* while_ugedivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10009; /* while_ugesivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10019; /* while_ugedivnx2bi */

    default:
      return -1;
    }
}

 int
recog_606 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (pattern1254 (x6, 
E_SImode) != 0
          || !
#line 3524 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == -UINTVAL (operands[3])))
        return -1;
      return 282; /* subsi3_compare1_imm */

    case E_DImode:
      if (pattern1254 (x6, 
E_DImode) != 0
          || !
#line 3524 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == -UINTVAL (operands[3])))
        return -1;
      return 283; /* subdi3_compare1_imm */

    default:
      return -1;
    }
}

 int
recog_608 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) != E_TImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LTU
          || GET_MODE (x6) != E_TImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 66
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != SIGN_EXTEND
          || GET_MODE (x9) != E_TImode)
        return -1;
      x10 = XEXP (x3, 1);
      if (GET_CODE (x10) != SIGN_EXTEND
          || GET_MODE (x10) != E_TImode)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != NEG
          || GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != PLUS
          || GET_MODE (x12) != E_DImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != LTU
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 66
          || GET_MODE (x14) != E_CCmode)
        return -1;
      x15 = XEXP (x13, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != NEG
          || GET_MODE (x17) != E_DImode)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != E_DImode)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != LTU
          || GET_MODE (x19) != E_DImode)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 66
          || GET_MODE (x20) != E_CCmode)
        return -1;
      x21 = XEXP (x19, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XEXP (x2, 0);
      if (GET_MODE (x22) != E_CC_Vmode
          || GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x4) != E_TImode)
        return -1;
      x23 = XEXP (x9, 0);
      operands[1] = x23;
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x24 = XEXP (x12, 1);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      x25 = XEXP (x18, 1);
      if (!rtx_equal_p (x25, operands[1]))
        return -1;
      return 278; /* negvdi_carryinV */

    case REG:
    case SUBREG:
      operands[1] = x5;
      x10 = XEXP (x3, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XEXP (x2, 0);
      if (GET_MODE (x22) != E_CC_NZmode
          || GET_MODE (x3) != E_CC_NZmode)
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      x17 = XEXP (x16, 1);
      switch (GET_CODE (x17))
        {
        case NEG:
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x17) != E_SImode)
                return -1;
              return 357; /* negsi2_compare0 */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x17) != E_DImode)
                return -1;
              return 358; /* negdi2_compare0 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern1174 (x1, 
NEG) != 0
              || !register_operand (operands[0], E_DImode))
            return -1;
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[1]))
            return -1;
          return 359; /* *negsi2_compare0_uxtw */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern908 (x1, 
ASHIFT))
        {
        case 0:
          return 360; /* *neg_lslsi3_compare0 */

        case 1:
          return 363; /* *neg_lsldi3_compare0 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern908 (x1, 
ASHIFTRT))
        {
        case 0:
          return 361; /* *neg_asrsi3_compare0 */

        case 1:
          return 364; /* *neg_asrdi3_compare0 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern908 (x1, 
LSHIFTRT))
        {
        case 0:
          return 362; /* *neg_lsrsi3_compare0 */

        case 1:
          return 365; /* *neg_lsrdi3_compare0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_612 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case PLUS:
      return recog_607 (x1, insn, pnum_clobbers);

    case MINUS:
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CC_NZmode
              || GET_MODE (x6) != E_CC_NZmode)
            return -1;
          x10 = XEXP (x7, 1);
          switch (GET_CODE (x10))
            {
            case ASHIFT:
              x11 = XEXP (x4, 1);
              if (GET_CODE (x11) != MINUS)
                return -1;
              x12 = XEXP (x11, 1);
              if (GET_CODE (x12) != ASHIFT)
                return -1;
              x13 = XEXP (x10, 1);
              operands[3] = x13;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x12, 1);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              x16 = XEXP (x10, 0);
              switch (GET_CODE (x16))
                {
                case REG:
                case SUBREG:
                  operands[2] = x16;
                  x17 = XEXP (x12, 0);
                  if (!rtx_equal_p (x17, operands[2]))
                    return -1;
                  switch (pattern1170 (x1))
                    {
                    case 0:
                      return 145; /* *subs_shift_imm_si */

                    case 1:
                      return 148; /* *subs_shift_imm_di */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  switch (pattern1299 (x1, 
SIGN_EXTEND))
                    {
                    case 0:
                      return 187; /* *subs_extendqi_shift_si */

                    case 1:
                      return 191; /* *subs_extendhi_shift_si */

                    case 2:
                      return 195; /* *subs_extendsi_shift_si */

                    case 3:
                      return 189; /* *subs_extendqi_shift_di */

                    case 4:
                      return 193; /* *subs_extendhi_shift_di */

                    case 5:
                      return 197; /* *subs_extendsi_shift_di */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern1299 (x1, 
ZERO_EXTEND))
                    {
                    case 0:
                      return 188; /* *subs_zero_extendqi_shift_si */

                    case 1:
                      return 192; /* *subs_zero_extendhi_shift_si */

                    case 2:
                      return 196; /* *subs_zero_extendsi_shift_si */

                    case 3:
                      return 190; /* *subs_zero_extendqi_shift_di */

                    case 4:
                      return 194; /* *subs_zero_extendhi_shift_di */

                    case 5:
                      return 198; /* *subs_zero_extendsi_shift_di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern1171 (x1, 
ASHIFTRT))
                {
                case 0:
                  return 146; /* *subs_shift_imm_si */

                case 1:
                  return 149; /* *subs_shift_imm_di */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern1171 (x1, 
LSHIFTRT))
                {
                case 0:
                  return 147; /* *subs_shift_imm_si */

                case 1:
                  return 150; /* *subs_shift_imm_di */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern1173 (x1, 
SIGN_EXTEND))
                {
                case 0:
                  return 163; /* *subs_extendqi_si */

                case 1:
                  return 167; /* *subs_extendhi_si */

                case 2:
                  return 171; /* *subs_extendsi_si */

                case 3:
                  return 165; /* *subs_extendqi_di */

                case 4:
                  return 169; /* *subs_extendhi_di */

                case 5:
                  return 173; /* *subs_extendsi_di */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern1173 (x1, 
ZERO_EXTEND))
                {
                case 0:
                  return 164; /* *subs_zero_extendqi_si */

                case 1:
                  return 168; /* *subs_zero_extendhi_si */

                case 2:
                  return 172; /* *subs_zero_extendsi_si */

                case 3:
                  return 166; /* *subs_zero_extendqi_di */

                case 4:
                  return 170; /* *subs_zero_extendhi_di */

                case 5:
                  return 174; /* *subs_zero_extendsi_di */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[2] = x10;
              x11 = XEXP (x4, 1);
              switch (GET_CODE (x11))
                {
                case MINUS:
                  x14 = XEXP (x11, 0);
                  if (!rtx_equal_p (x14, operands[1]))
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (!rtx_equal_p (x12, operands[2]))
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_SImode:
                      if (pattern1286 (x11, 
E_SImode) != 0)
                        return -1;
                      return 279; /* *subsi3_compare0 */

                    case E_DImode:
                      if (pattern1286 (x11, 
E_DImode) != 0)
                        return -1;
                      return 280; /* *subdi3_compare0 */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (pattern1207 (x1, 
MINUS) != 0
                      || !register_operand (operands[1], E_SImode)
                      || !register_operand (operands[2], E_SImode)
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x14 = XEXP (x11, 0);
                  x18 = XEXP (x14, 0);
                  if (!rtx_equal_p (x18, operands[1]))
                    return -1;
                  x19 = XEXP (x14, 1);
                  if (!rtx_equal_p (x19, operands[2]))
                    return -1;
                  return 281; /* *subsi3_compare0_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != SIGN_EXTEND)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != MINUS)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x3) != E_CC_Vmode
              || GET_MODE (x6) != E_CC_Vmode)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x10 = XEXP (x7, 1);
          switch (GET_CODE (x10))
            {
            case GEU:
            case LTU:
              operands[2] = x10;
              x23 = XEXP (x20, 1);
              operands[3] = x23;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1325 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 342; /* *subsi3_carryinV_z2 */

                case E_TImode:
                  if (pattern1325 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 343; /* *subdi3_carryinV_z2 */

                default:
                  return -1;
                }

            case PLUS:
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x23 = XEXP (x20, 1);
              if (GET_CODE (x23) != PLUS)
                return -1;
              x14 = XEXP (x11, 0);
              if (GET_CODE (x14) != MINUS)
                return -1;
              x24 = XEXP (x16, 0);
              operands[2] = x24;
              x13 = XEXP (x10, 1);
              operands[3] = x13;
              x25 = XEXP (x23, 0);
              operands[4] = x25;
              x26 = XEXP (x23, 1);
              if (!rtx_equal_p (x26, operands[2]))
                return -1;
              x18 = XEXP (x14, 0);
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x14, 1);
              if (!rtx_equal_p (x19, operands[2]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[4]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1351 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 344; /* *subsi3_carryinV */

                case E_TImode:
                  if (pattern1351 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 345; /* *subdi3_carryinV */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x6) != E_CC_Vmode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case MINUS:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != MINUS)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != SIGN_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x27 = XEXP (x8, 1);
          operands[2] = x27;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x12 = XEXP (x11, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              x28 = XEXP (x9, 1);
              if (GET_CODE (x28) != SIGN_EXTEND)
                return -1;
              x29 = XEXP (x28, 0);
              if (!rtx_equal_p (x29, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1329 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 267; /* subvsi_insn */

                case E_TImode:
                  if (pattern1329 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 268; /* subvdi_insn */

                default:
                  return -1;
                }

            case CONST_INT:
              x28 = XEXP (x9, 1);
              if (!rtx_equal_p (x28, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1326 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 269; /* subvsi_imm */

                case E_TImode:
                  if (pattern1326 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 270; /* subvdi_imm */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != NEG)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != SIGN_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != NEG)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1277 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 271; /* negvsi_insn */

            case E_TImode:
              if (pattern1277 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 272; /* negvdi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_608 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      if (GET_MODE (x3) != E_CCmode
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          res = recog_605 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          res = recog_606 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != MINUS)
        return -1;
      operands[1] = x7;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (aarch64_reg_or_zero (operands[2], E_SImode)
          && pattern1175 (x11, 
E_SImode) == 0)
        return 284; /* subsi3_compare1 */
      if (!aarch64_reg_or_zero (operands[2], E_DImode)
          || pattern1175 (x11, 
E_DImode) != 0)
        return -1;
      return 285; /* subdi3_compare1 */

    case ZERO_EXTEND:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x9 = XEXP (x6, 1);
      switch (GET_CODE (x9))
        {
        case GEU:
        case LTU:
          operands[2] = x9;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x12 = XEXP (x11, 1);
          operands[3] = x12;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1255 (x11, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 338; /* *usubsi3_carryinC_z2 */

            case E_TImode:
              if (pattern1255 (x11, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 339; /* *usubdi3_carryinC_z2 */

            default:
              return -1;
            }

        case PLUS:
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != ZERO_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS)
            return -1;
          x14 = XEXP (x11, 0);
          if (GET_CODE (x14) != MINUS
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x22 = XEXP (x20, 0);
          operands[2] = x22;
          x28 = XEXP (x9, 1);
          operands[3] = x28;
          x12 = XEXP (x11, 1);
          operands[4] = x12;
          x18 = XEXP (x14, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          x19 = XEXP (x14, 1);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1307 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 340; /* *usubsi3_carryinC */

            case E_TImode:
              if (pattern1307 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 341; /* *usubdi3_carryinC */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x9, 0) != 0L)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != ZERO_EXTEND
              || GET_MODE (x3) != E_CC_Zmode
              || GET_MODE (x6) != E_CC_Zmode)
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_SImode:
              switch (pattern1239 (x11, 
E_SImode))
                {
                case 0:
                  return 699; /* *andssi_compare0 */

                case 1:
                  return 701; /* *andssi_compare0 */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1239 (x11, 
E_DImode))
                {
                case 0:
                  return 700; /* *andsdi_compare0 */

                case 1:
                  return 702; /* *andsdi_compare0 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x9 = XEXP (x6, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_CC_NZVmode
          || GET_MODE (x6) != E_CC_NZVmode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          x11 = XEXP (x4, 1);
          switch (GET_CODE (x11))
            {
            case AND:
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_SImode:
                  if (pattern1278 (x11, 
E_SImode) != 0)
                    return -1;
                  return 512; /* *andsi3_compare0 */

                case E_DImode:
                  if (pattern1278 (x11, 
E_DImode) != 0)
                    return -1;
                  return 513; /* *anddi3_compare0 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1207 (x1, 
AND) != 0
                  || !register_operand (operands[1], E_SImode)
                  || !aarch64_logical_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_DImode))
                return -1;
              x14 = XEXP (x11, 0);
              x18 = XEXP (x14, 0);
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x14, 1);
              if (!rtx_equal_p (x19, operands[2]))
                return -1;
              return 514; /* *andsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern1084 (x1, 
ASHIFT))
            {
            case 0:
              return 515; /* *and_ashlsi3_compare0 */

            case 1:
              return 520; /* *and_ashldi3_compare0 */

            case 2:
              return 525; /* *and_ashlsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern1084 (x1, 
ASHIFTRT))
            {
            case 0:
              return 516; /* *and_ashrsi3_compare0 */

            case 1:
              return 521; /* *and_ashrdi3_compare0 */

            case 2:
              return 526; /* *and_ashrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern1084 (x1, 
LSHIFTRT))
            {
            case 0:
              return 517; /* *and_lshrsi3_compare0 */

            case 1:
              return 522; /* *and_lshrdi3_compare0 */

            case 2:
              return 527; /* *and_lshrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern1084 (x1, 
ROTATERT))
            {
            case 0:
              return 518; /* *and_rotrsi3_compare0 */

            case 1:
              return 523; /* *and_rotrdi3_compare0 */

            case 2:
              return 528; /* *and_rotrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern1084 (x1, 
ROTATE))
            {
            case 0:
              return 519; /* *and_rotlsi3_compare0 */

            case 1:
              return 524; /* *and_rotldi3_compare0 */

            case 2:
              return 529; /* *and_rotlsi3_compare0_uxtw */

            default:
              return -1;
            }

        case NOT:
          x21 = XEXP (x8, 0);
          switch (GET_CODE (x21))
            {
            case REG:
            case SUBREG:
              operands[1] = x21;
              x10 = XEXP (x7, 1);
              operands[2] = x10;
              x11 = XEXP (x4, 1);
              switch (GET_CODE (x11))
                {
                case AND:
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != NOT)
                    return -1;
                  x18 = XEXP (x14, 0);
                  if (!rtx_equal_p (x18, operands[1]))
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (!rtx_equal_p (x12, operands[2]))
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_SImode:
                      if (pattern1300 (x1, 
E_SImode) != 0)
                        return -1;
                      return 597; /* *and_one_cmplsi3_compare0 */

                    case E_DImode:
                      if (pattern1300 (x1, 
E_DImode) != 0)
                        return -1;
                      return 598; /* *and_one_cmpldi3_compare0 */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != AND
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x18 = XEXP (x14, 0);
                  if (GET_CODE (x18) != NOT
                      || GET_MODE (x18) != E_SImode
                      || GET_MODE (x7) != E_SImode
                      || GET_MODE (x8) != E_SImode
                      || !register_operand (operands[1], E_SImode)
                      || !register_operand (operands[2], E_SImode)
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x30 = XEXP (x18, 0);
                  if (!rtx_equal_p (x30, operands[1]))
                    return -1;
                  x19 = XEXP (x14, 1);
                  if (!rtx_equal_p (x19, operands[2]))
                    return -1;
                  return 599; /* *and_one_cmplsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern1139 (x1, 
ASHIFT))
                {
                case 0:
                  return 662; /* *and_one_cmpl_ashlsi3_compare0 */

                case 1:
                  return 667; /* *and_one_cmpl_ashldi3_compare0 */

                case 2:
                  return 672; /* *and_one_cmpl_ashlsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern1139 (x1, 
ASHIFTRT))
                {
                case 0:
                  return 663; /* *and_one_cmpl_ashrsi3_compare0 */

                case 1:
                  return 668; /* *and_one_cmpl_ashrdi3_compare0 */

                case 2:
                  return 673; /* *and_one_cmpl_ashrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern1139 (x1, 
LSHIFTRT))
                {
                case 0:
                  return 664; /* *and_one_cmpl_lshrsi3_compare0 */

                case 1:
                  return 669; /* *and_one_cmpl_lshrdi3_compare0 */

                case 2:
                  return 674; /* *and_one_cmpl_lshrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ROTATERT:
              switch (pattern1139 (x1, 
ROTATERT))
                {
                case 0:
                  return 665; /* *and_one_cmpl_rotrsi3_compare0 */

                case 1:
                  return 670; /* *and_one_cmpl_rotrdi3_compare0 */

                case 2:
                  return 675; /* *and_one_cmpl_rotrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ROTATE:
              switch (pattern1139 (x1, 
ROTATE))
                {
                case 0:
                  return 666; /* *and_one_cmpl_rotlsi3_compare0 */

                case 1:
                  return 671; /* *and_one_cmpl_rotldi3_compare0 */

                case 2:
                  return 676; /* *and_one_cmpl_rotlsi3_compare0_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      return split_1 (x1, insn);

    case TRUNCATE:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8QImode:
          switch (pattern564 (x2, 
E_VNx8QImode))
            {
            case 0:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1035 (insn, operands);

            case 1:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1041 (insn, operands);

            case 2:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1047 (insn, operands);

            case 3:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1053 (insn, operands);

            case 4:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1059 (insn, operands);

            case 5:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1065 (insn, operands);

            default:
              return NULL;
            }

        case E_VNx4QImode:
          switch (pattern564 (x2, 
E_VNx4QImode))
            {
            case 0:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1036 (insn, operands);

            case 1:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1042 (insn, operands);

            case 2:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1048 (insn, operands);

            case 3:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1054 (insn, operands);

            case 4:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1060 (insn, operands);

            case 5:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1066 (insn, operands);

            default:
              return NULL;
            }

        case E_VNx2QImode:
          switch (pattern564 (x2, 
E_VNx2QImode))
            {
            case 0:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1037 (insn, operands);

            case 1:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1043 (insn, operands);

            case 2:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1049 (insn, operands);

            case 3:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1055 (insn, operands);

            case 4:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1061 (insn, operands);

            case 5:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1067 (insn, operands);

            default:
              return NULL;
            }

        case E_VNx4HImode:
          switch (pattern564 (x2, 
E_VNx4HImode))
            {
            case 0:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1038 (insn, operands);

            case 1:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1044 (insn, operands);

            case 2:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1050 (insn, operands);

            case 3:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1056 (insn, operands);

            case 4:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1062 (insn, operands);

            case 5:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1068 (insn, operands);

            default:
              return NULL;
            }

        case E_VNx2HImode:
          switch (pattern564 (x2, 
E_VNx2HImode))
            {
            case 0:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1039 (insn, operands);

            case 1:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1045 (insn, operands);

            case 2:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1051 (insn, operands);

            case 3:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1057 (insn, operands);

            case 4:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1063 (insn, operands);

            case 5:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1069 (insn, operands);

            default:
              return NULL;
            }

        case E_VNx2SImode:
          switch (pattern564 (x2, 
E_VNx2SImode))
            {
            case 0:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1040 (insn, operands);

            case 1:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1046 (insn, operands);

            case 2:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1052 (insn, operands);

            case 3:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1058 (insn, operands);

            case 4:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1064 (insn, operands);

            case 5:
              if (!(
#line 3457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0) && 
#line 3459 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_1070 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern854 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1101 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1134 (insn, operands);

    case E_VNx4SFmode:
      if (pattern854 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1112 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1145 (insn, operands);

    case E_VNx2DFmode:
      if (pattern854 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1123 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1156 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern854 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1100 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1133 (insn, operands);

    case E_VNx4SFmode:
      if (pattern854 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1111 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1144 (insn, operands);

    case E_VNx2DFmode:
      if (pattern854 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1122 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1155 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1241 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1248 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2907 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1268 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1273 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2915 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1293 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1307 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2923 (insn, operands);
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2816 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2857 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2897 (insn, operands);
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2780 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2827 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2867 (insn, operands);
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2814 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2855 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2895 (insn, operands);
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2801 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2844 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2884 (insn, operands);
}

 rtx_insn *
split_38 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2788 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2833 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2873 (insn, operands);
}

 rtx_insn *
split_43 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2774 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2822 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2862 (insn, operands);
}

 rtx_insn *
split_48 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2808 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2850 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2890 (insn, operands);
}

 rtx_insn *
split_54 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2783 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2829 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2869 (insn, operands);
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1032 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1649 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1722 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1774 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1662 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1735 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1787 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1675 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1748 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1800 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1688 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1761 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1813 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1695 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1872 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1702 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1879 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1709 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1886 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1826 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1839 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1852 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1865 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1893 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1900 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1907 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_65 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1032 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1641 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1714 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1766 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1654 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1727 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1779 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1667 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1740 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1792 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1680 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1753 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1805 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1689 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1866 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1696 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1873 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1703 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1880 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1818 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1831 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1844 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1857 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1887 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1894 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1901 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[4] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern696 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1219 (insn, operands);

        case E_VNx8QImode:
          if (pattern696 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1236 (insn, operands);

        case E_VNx4QImode:
          if (pattern696 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1253 (insn, operands);

        case E_VNx2QImode:
          if (pattern696 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1270 (insn, operands);

        case E_VNx8HImode:
          if (pattern696 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1287 (insn, operands);

        case E_VNx4HImode:
          if (pattern696 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1304 (insn, operands);

        case E_VNx2HImode:
          if (pattern696 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1321 (insn, operands);

        case E_VNx4SImode:
          if (pattern696 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1338 (insn, operands);

        case E_VNx2SImode:
          if (pattern696 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1355 (insn, operands);

        case E_VNx2DImode:
          if (pattern696 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1372 (insn, operands);

        default:
          return NULL;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1034 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1506 (insn, operands);

        case E_VNx8QImode:
          if (pattern1034 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1509 (insn, operands);

        case E_VNx4QImode:
          if (pattern1034 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1512 (insn, operands);

        case E_VNx2QImode:
          if (pattern1034 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1515 (insn, operands);

        case E_VNx8HImode:
          if (pattern1034 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1518 (insn, operands);

        case E_VNx4HImode:
          if (pattern1034 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1521 (insn, operands);

        case E_VNx2HImode:
          if (pattern1034 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1524 (insn, operands);

        case E_VNx4SImode:
          if (pattern1034 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1527 (insn, operands);

        case E_VNx2SImode:
          if (pattern1034 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1530 (insn, operands);

        case E_VNx2DImode:
          if (pattern1034 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1533 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_75 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 123
      || GET_MODE (x2) != E_BLKmode)
    return NULL;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 125
      || GET_MODE (x3) != E_VNx2DImode)
    return NULL;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return NULL;
  x6 = XVECEXP (x2, 0, 0);
  operands[5] = x6;
  if (!register_operand (operands[5], E_VNx2BImode))
    return NULL;
  x7 = XVECEXP (x2, 0, 1);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x8 = XVECEXP (x3, 0, 0);
  operands[6] = x8;
  x9 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x9) != E_VNx2DImode)
    return NULL;
  x10 = XVECEXP (x2, 0, 3);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_DImode))
    return NULL;
  x11 = XVECEXP (x2, 0, 4);
  operands[3] = x11;
  switch (pattern1296 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_973 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1303 ())
            {
            case 0:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_975 (insn, operands);
              break;

            case 1:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_977 (insn, operands);
              break;

            case 2:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_979 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_981 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_983 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_985 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_987 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_989 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1303 ())
            {
            case 0:
              if ((
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_990 (insn, operands);
              break;

            case 1:
              if ((
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_991 (insn, operands);
              break;

            case 2:
              if ((
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_992 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_993 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_994 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_995 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_996 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x12 = XVECEXP (x2, 0, 5);
      if (GET_MODE (x12) == E_VNx2QImode
          && aarch64_gather_scale_operand_b (operands[3], E_DImode))
        {
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          if (register_operand (operands[4], E_VNx2DImode)
              && (
#line 2616 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2621 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
            return gen_split_997 (insn, operands);
        }
      if (GET_MODE (x12) == E_VNx2HImode
          && aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          if (register_operand (operands[4], E_VNx2DImode)
              && (
#line 2616 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2621 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
            return gen_split_998 (insn, operands);
        }
      if (GET_MODE (x12) != E_VNx2SImode
          || !aarch64_gather_scale_operand_w (operands[3], E_DImode))
        return NULL;
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_VNx2DImode)
          || !(
#line 2616 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2621 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
        return NULL;
      return gen_split_999 (insn, operands);

    case 3:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_974 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1303 ())
            {
            case 0:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_976 (insn, operands);
              break;

            case 1:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_978 (insn, operands);
              break;

            case 2:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_980 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_982 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_984 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_986 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_988 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_79 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern2 (x3))
        {
        case 0:
          if (aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              && 
#line 2511 "../../gcc/config/aarch64/aarch64.md"
(epilogue_completed))
            return gen_split_14 (insn, operands);
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_SImode)
              || !(
#line 2543 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx) && 
#line 2553 "../../gcc/config/aarch64/aarch64.md"
( epilogue_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && aarch64_split_add_offset_immediate (operands[2], SImode))))
            return NULL;
          return gen_split_16 (insn, operands);

        case 1:
          if (aarch64_pluslong_strict_immedate (operands[2], E_DImode)
              && 
#line 2511 "../../gcc/config/aarch64/aarch64.md"
(epilogue_completed))
            return gen_split_15 (insn, operands);
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_DImode)
              || !(
#line 2543 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx) && 
#line 2553 "../../gcc/config/aarch64/aarch64.md"
( epilogue_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && aarch64_split_add_offset_immediate (operands[2], DImode))))
            return NULL;
          return gen_split_17 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case LSHIFTRT:
          switch (pattern443 (x3))
            {
            case 0:
              if (!
#line 5125 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   SImode)))
                return NULL;
              return gen_split_41 (insn, operands);

            case 1:
              if (!
#line 5125 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   DImode)))
                return NULL;
              return gen_split_45 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern444 (x3))
            {
            case 0:
              if (!
#line 5147 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[3]))
   && (PLUS != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_49 (insn, operands);

            case 1:
              if (!
#line 5147 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[3]))
   && (PLUS != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_53 (insn, operands);

            case 2:
              if (!
#line 5176 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[4]))
   && (PLUS != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_57 (insn, operands);

            case 3:
              if (!
#line 5176 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[4]))
   && (PLUS != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != PLUS)
        return NULL;
      switch (pattern374 (x3))
        {
        case 0:
          if (!(
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5016 "../../gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_191 (insn, operands);

        case 1:
          if (!(
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5016 "../../gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_192 (insn, operands);

        case 2:
          if (!(
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5016 "../../gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_193 (insn, operands);

        default:
          return NULL;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != VEC_SELECT)
        return NULL;
      switch (pattern446 (x3))
        {
        case 0:
          if (!(
#line 7302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7304 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_204 (insn, operands);

        case 1:
          if (!(
#line 7302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7304 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_205 (insn, operands);

        case 2:
          if (!(
#line 7302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7304 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_206 (insn, operands);

        case 3:
          if (!(
#line 7302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7304 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_207 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          if (XINT (x4, 1) != 125)
            return NULL;
          x7 = XVECEXP (x4, 0, 1);
          switch (GET_CODE (x7))
            {
            case ASHIFT:
              x8 = XEXP (x7, 1);
              operands[3] = x8;
              switch (pattern796 (x3))
                {
                case 0:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1383 (insn, operands);

                case 1:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1384 (insn, operands);

                case 2:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1385 (insn, operands);

                case 3:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1386 (insn, operands);

                case 4:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1387 (insn, operands);

                case 5:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1388 (insn, operands);

                case 6:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1389 (insn, operands);

                case 7:
                  if (!(
#line 4232 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4234 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
                    return NULL;
                  return gen_split_1390 (insn, operands);

                case 8:
                  if (!(
#line 4253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4255 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
                    return NULL;
                  return gen_split_1391 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFTRT:
              switch (pattern770 (x3))
                {
                case 0:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_2978 (insn, operands);

                case 1:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_2980 (insn, operands);

                case 2:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_2982 (insn, operands);

                case 3:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_2984 (insn, operands);

                default:
                  return NULL;
                }

            case LSHIFTRT:
              switch (pattern770 (x3))
                {
                case 0:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_2979 (insn, operands);

                case 1:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_2981 (insn, operands);

                case 2:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_2983 (insn, operands);

                case 3:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_2985 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 3:
          if (XINT (x4, 1) != 306)
            return NULL;
          switch (pattern623 (x3))
            {
            case 0:
              if (!(
#line 10735 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2676 (insn, operands);

            case 1:
              if (!(
#line 10735 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2677 (insn, operands);

            case 2:
              if (!(
#line 10735 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2678 (insn, operands);

            case 3:
              if (!(
#line 10735 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2679 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (pattern38 (x4, 
E_DImode) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x6 = XEXP (x4, 0);
      x9 = XVECEXP (x6, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x6, 0, 2);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      switch (pattern19 ())
        {
        case 0:
          if (!(
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2664 (insn, operands);

        case 1:
          if (!(
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2667 (insn, operands);

        case 2:
          if (!(
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2670 (insn, operands);

        case 3:
          if (!(
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2673 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (pattern20 (x3))
        {
        case 0:
          if (!(
#line 10823 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10828 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2688 (insn, operands);

        case 1:
          if (!(
#line 10862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10867 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2691 (insn, operands);

        case 2:
          if (!(
#line 10903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10908 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2694 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_98 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2403 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2413 (insn, operands);
}

 rtx_insn *
split_102 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2482 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2492 (insn, operands);
}

 rtx_insn *
split_106 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2402 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2412 (insn, operands);
}

 rtx_insn *
split_112 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2441 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2451 (insn, operands);
}

 rtx_insn *
split_119 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3433 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2460 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3433 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2470 (insn, operands);
}

 rtx_insn *
split_126 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3432 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2479 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3432 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2489 (insn, operands);
}

 rtx_insn *
split_134 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern1320 (x1, 
GEU))
    {
    case 0:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2083 (insn, operands);

    case 1:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2093 (insn, operands);

    case 2:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2123 (insn, operands);

    case 3:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2103 (insn, operands);

    case 4:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2133 (insn, operands);

    case 5:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2153 (insn, operands);

    case 6:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2113 (insn, operands);

    case 7:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2143 (insn, operands);

    case 8:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2163 (insn, operands);

    case 9:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2173 (insn, operands);

    case 10:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2183 (insn, operands);

    case 11:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2193 (insn, operands);

    case 12:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2223 (insn, operands);

    case 13:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2203 (insn, operands);

    case 14:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2233 (insn, operands);

    case 15:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2253 (insn, operands);

    case 16:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2213 (insn, operands);

    case 17:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2243 (insn, operands);

    case 18:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2263 (insn, operands);

    case 19:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2273 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V2DFmode))
    {
      switch (pattern921 (
E_V2DFmode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_140 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_141 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_142 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_143 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_144 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_145 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_146 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_147 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_V2DFmode))
    {
      if (register_operand (operands[1], E_V2DFmode))
        {
          switch (pattern975 ())
            {
            case 0:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_204 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_205 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_206 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_207 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_208 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_209 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 6:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_210 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 7:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_211 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (peep2_current_count >= 3)
        {
          x2 = PATTERN (peep2_next_insn (2));
          if (pattern974 (x2, 
E_V2DFmode) == 0
              && 
#line 304 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, false, V2DFmode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_239 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (pattern920 (x2, 
E_V2DFmode) != 0
      || !
#line 325 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, true, V2DFmode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_243 (insn, operands);
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V4SFmode))
    {
      switch (pattern921 (
E_V4SFmode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_132 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_133 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_134 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_135 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_136 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_137 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_138 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_139 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V4SFmode)
      || !register_operand (operands[1], E_V4SFmode))
    return NULL;
  switch (pattern975 ())
    {
    case 0:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_196 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_197 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_198 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_199 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_200 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_201 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_202 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_203 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V4SImode))
    {
      switch (pattern921 (
E_V4SImode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_108 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_109 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_110 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_111 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_112 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_113 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_114 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_115 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode))
    return NULL;
  switch (pattern975 ())
    {
    case 0:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_172 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_173 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_174 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_175 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_176 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_177 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_178 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_179 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V2SImode))
    {
      switch (pattern918 (
E_V2SImode))
        {
        case 0:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_23 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_29 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_35 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_41 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_47 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_53 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_V2SImode))
    {
      if (register_operand (operands[1], E_V2SImode))
        {
          switch (pattern972 ())
            {
            case 0:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_59 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_65 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_71 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_77 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_83 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_89 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (peep2_current_count >= 3)
        {
          x2 = PATTERN (peep2_next_insn (2));
          if (pattern974 (x2, 
E_V2SImode) == 0
              && 
#line 304 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, false, V2SImode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_236 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (pattern920 (x2, 
E_V2SImode) != 0
      || !
#line 325 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, true, V2SImode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_240 (insn, operands);
}
